package com.thalesgroup.cheddar.MARTE2cheddar;

import org.eclipse.core.resources.IFile;

import com.thalesgroup.java.log.Log;
/**
 * Utility class for running Cheddar in a thread.
 * Only one instance is allowed at a time.
 * 
 * <copyright>
 * Thales MARTE to Cheddar (Copyright (c) THALES 2007 All rights reserved) is free software; you can redistribute itand/or modify
 * it under the terms of the Eclipse Public License as published in http://www.eclipse.org/legal/epl-v10.html
 *
 * Thales MARTE to Cheddar is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License for more details.
 * </copyright>
 * 
 * @author Nicolas Vienne
 *
 */
public class CheddarThread extends Thread {
	static Boolean is_running = false;
	IFile infile = null;
	
	public CheddarThread(IFile infile) {
		super();
		this.infile = infile;
	}

	@Override
	public void run() {
		if(is_running){
			Log.warningMessage(Activator.PLUGIN_ID,"Cheddar is already running ...");
		} else {
			is_running = true;
			super.run();
			CheddarRunner.Exec(infile);
			is_running = false;
		}
	}
}
