package com.thalesgroup.cheddar.MARTE2cheddar.actions;

import org.eclipse.core.resources.IFile;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.ProgressMonitorDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.ITreeSelection;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;

import com.thalesgroup.cheddar.MARTE2cheddar.Activator;
import com.thalesgroup.cheddar.MARTE2cheddar.CheddarThread;
import com.thalesgroup.cheddar.MARTE2cheddar.MARTE2CheddarXML;
import com.thalesgroup.java.log.Log;

/**
 * 
 * <copyright>
 * Thales MARTE to Cheddar (Copyright (c) THALES 2007 All rights reserved) is free software; you can redistribute itand/or modify
 * it under the terms of the Eclipse Public License as published in http://www.eclipse.org/legal/epl-v10.html
 *
 * Thales MARTE to Cheddar is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License for more details.
 * </copyright>
 * 
 * @author Nicolas Vienne
 *
 */
public class ExportAndRunCheddar implements IWorkbenchWindowActionDelegate {
	IFile infile = null;
	
	public void dispose() {
		
	}

	
	public void init(IWorkbenchWindow window) {

	}

	public void run(IAction action) {
		Log.verboseMessage(Activator.PLUGIN_ID, "MARTE Export to Cheddar");
		if(infile != null) {
			try {
				MARTE2CheddarXML.getInstance().initExport(infile);
				new ProgressMonitorDialog(new Shell()).run(true, false, MARTE2CheddarXML.getInstance());
				IFile outfile = MARTE2CheddarXML.getInstance().result();
				if(action.getId().equals("MARTE2cheddar.ExportAndRunCheddar") || action.getId().equals("com.thalesgroup.cheddar.MARTE2cheddar.CheddarExportRunAction")) {
					if (outfile != null) {
						new CheddarThread(outfile).start();
					}
					else {
						Log.warningMessage(Activator.PLUGIN_ID, "No information to transform on file "+infile.getName());
					}
				}
			} catch (Exception exception) {
				Log.errorMessage(Activator.PLUGIN_ID,"Error while running ExportAndRunCheddar",exception); 
			}
			
		}
	}

	
	public void selectionChanged(IAction action, ISelection selection) {
		if (selection instanceof ITreeSelection){
			ITreeSelection treeSelection = (ITreeSelection) selection;
			Object firstElement = treeSelection.getFirstElement();
			if (firstElement instanceof IFile){
				infile = (IFile) firstElement;
			}
		}
	}
}
