package com.thalesgroup.cheddar.MARTE2cheddar.actions;

import java.io.IOException;
import java.net.URISyntaxException;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.ITreeSelection;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;

import com.thalesgroup.cheddar.MARTE2cheddar.Activator;
import com.thalesgroup.cheddar.MARTE2cheddar.MARTE2CheddarXML;
import com.thalesgroup.java.log.Log;

/**
 * 
 * <copyright>
 * Thales MARTE to Cheddar (Copyright (c) THALES 2007 All rights reserved) is free software; you can redistribute itand/or modify
 * it under the terms of the Eclipse Public License as published in http://www.eclipse.org/legal/epl-v10.html
 *
 * Thales MARTE to Cheddar is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License for more details.
 * </copyright>
 * 
 * @author Nicolas Vienne
 *
 */
public class LaunchMARTE2Cheddar implements IWorkbenchWindowActionDelegate {
	
	//protected IFile infile = null;
	protected ITreeSelection myselection = null;
	/**
	 * The constructor.
	 */
	public LaunchMARTE2Cheddar() {
		
	}

	/**
	 * The action has been activated. The argument of the
	 * method represents the 'real' action sitting
	 * in the workbench UI.
	 * @throws CoreException 
	 * @throws URISyntaxException 
	 * @throws IOException 
	 * @see IWorkbenchWindowActionDelegate#run
	 */

	public void run(IAction action) {
		if(myselection != null) {
			try {
				MARTE2CheddarXML m2x = MARTE2CheddarXML.getInstance();
				Log.debugMessage(Activator.PLUGIN_ID, "MARTE2CheddarXML instance"+m2x.toString());
				for( Object o : myselection.toArray()) {
					if (o instanceof IFile) {
						IFile infile = (IFile) o;
						m2x.MARTE2Cheddar(infile);
					}
				}
				
			} catch (Exception exception) {
				Log.errorMessage(Activator.PLUGIN_ID,"Error while exporting from MARTE to cheddar",exception);
			}
			
		}
	}

	/**
	 * Selection in the workbench has been changed. We 
	 * can change the state of the 'real' action here
	 * if we want, but this can only happen after 
	 * the delegate has been created.
	 * @see IWorkbenchWindowActionDelegate#selectionChanged
	 */
	public void selectionChanged(IAction action, ISelection selection) {
		if (selection instanceof ITreeSelection){
			ITreeSelection treeSelection = (ITreeSelection) selection;
			myselection = treeSelection;
		}
	}

	/**
	 * We can use this method to dispose of any system
	 * resources we previously allocated.
	 * @see IWorkbenchWindowActionDelegate#dispose
	 */
	public void dispose() {
	}

	/**
	 * We will cache window object in order to
	 * be able to provide parent shell for the message dialog.
	 * @see IWorkbenchWindowActionDelegate#init
	 */
	public void init(IWorkbenchWindow window) {
	}
}