package com.thalesgroup.cheddar.MARTE2cheddar.actions;

import org.atl.engine.repositories.emf4atl.ASMEMFModel;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceImpl;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;

import com.thalesgroup.cheddar.MARTE2cheddar.Activator;
import com.thalesgroup.java.log.Log;
/**
 * 
 * <copyright>
 * Thales MARTE to Cheddar (Copyright (c) THALES 2007 All rights reserved) is free software; you can redistribute itand/or modify
 * it under the terms of the Eclipse Public License as published in http://www.eclipse.org/legal/epl-v10.html
 *
 * Thales MARTE to Cheddar is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License for more details.
 * </copyright>
 * 
 * @author Nicolas Vienne
 *
 */
public class LaunchTests implements IWorkbenchWindowActionDelegate {
	
	/**
	 * The constructor.
	 */
	public LaunchTests() {
	}

	
	/**
	 * The action has been activated. The argument of the
	 * method represents the 'real' action sitting
	 * in the workbench UI.
	 * @see IWorkbenchWindowActionDelegate#run
	 */
	public void run(IAction action) {
		
		if(action.getId().equals("MARTE2cheddar.debug.ShowModels")) {
			System.out.println("*** LOADED MODELS ***");
			ResourceSet resourceSet = ASMEMFModel.getResourceSet();
			EList resources = resourceSet.getResources();
			for (Object object : resources) {
				if (object instanceof XMIResourceImpl) {
					XMIResourceImpl xri = (XMIResourceImpl) object;
					Log.debugMessage(Activator.PLUGIN_ID, xri.getURI().toString());
				}
			}
		}
	}

	/**
	 * Selection in the workbench has been changed. We 
	 * can change the state of the 'real' action here
	 * if we want, but this can only happen after 
	 * the delegate has been created.
	 * @see IWorkbenchWindowActionDelegate#selectionChanged
	 */
	public void selectionChanged(IAction action, ISelection selection) {
	}

	/**
	 * We can use this method to dispose of any system
	 * resources we previously allocated.
	 * @see IWorkbenchWindowActionDelegate#dispose
	 */
	public void dispose() {
	}

	/**
	 * We will cache window object in order to
	 * be able to provide parent shell for the message dialog.
	 * @see IWorkbenchWindowActionDelegate#init
	 */
	public void init(IWorkbenchWindow window) {
	}
}