/**
 * <copyright>
 * Thales MARTE To Cheddar(Copyright (c) THALES 2007 All rights reserved)
 * is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published
 * in http://www.eclipse.org/legal/epl-v10.html
 * Thales MARTE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Eclipse Public License for more details.
 * </copyright>
 *
 * $Id: CheddarFactory.java,v 1.1 2008/01/23 16:59:01 emaes Exp $
 */
package cheddar;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see cheddar.CheddarPackage
 * @generated
 */
public interface CheddarFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	CheddarFactory eINSTANCE = cheddar.impl.CheddarFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>processor</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>processor</em>'.
	 * @generated
	 */
	processor createprocessor();

	/**
	 * Returns a new object of class '<em>scheduler</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>scheduler</em>'.
	 * @generated
	 */
	scheduler createscheduler();

	/**
	 * Returns a new object of class '<em>network</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>network</em>'.
	 * @generated
	 */
	network createnetwork();

	/**
	 * Returns a new object of class '<em>address space</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>address space</em>'.
	 * @generated
	 */
	address_space createaddress_space();

	/**
	 * Returns a new object of class '<em>task</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>task</em>'.
	 * @generated
	 */
	task createtask();

	/**
	 * Returns a new object of class '<em>offset</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>offset</em>'.
	 * @generated
	 */
	offset createoffset();

	/**
	 * Returns a new object of class '<em>parameter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>parameter</em>'.
	 * @generated
	 */
	parameter createparameter();

	/**
	 * Returns a new object of class '<em>event analyzer</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>event analyzer</em>'.
	 * @generated
	 */
	event_analyzer createevent_analyzer();

	/**
	 * Returns a new object of class '<em>buffer</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>buffer</em>'.
	 * @generated
	 */
	buffer createbuffer();

	/**
	 * Returns a new object of class '<em>buffer user</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>buffer user</em>'.
	 * @generated
	 */
	buffer_user createbuffer_user();

	/**
	 * Returns a new object of class '<em>dependency</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>dependency</em>'.
	 * @generated
	 */
	dependency createdependency();

	/**
	 * Returns a new object of class '<em>message</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>message</em>'.
	 * @generated
	 */
	message createmessage();

	/**
	 * Returns a new object of class '<em>resource user</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>resource user</em>'.
	 * @generated
	 */
	resource_user createresource_user();

	/**
	 * Returns a new object of class '<em>resource</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>resource</em>'.
	 * @generated
	 */
	resource createresource();

	/**
	 * Returns a new object of class '<em>Root</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Root</em>'.
	 * @generated
	 */
	Root createRoot();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	CheddarPackage getCheddarPackage();

} //CheddarFactory
