/**
 * <copyright>
 * Thales MARTE To Cheddar(Copyright (c) THALES 2007 All rights reserved)
 * is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published
 * in http://www.eclipse.org/legal/epl-v10.html
 * Thales MARTE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Eclipse Public License for more details.
 * </copyright>
 *
 * $Id: CheddarPackage.java,v 1.1 2008/01/23 16:59:01 emaes Exp $
 */
package cheddar;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see cheddar.CheddarFactory
 * @model kind="package"
 * @generated
 */
public interface CheddarPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "cheddar";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http:///cheddar.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "cheddar";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	CheddarPackage eINSTANCE = cheddar.impl.CheddarPackageImpl.init();

	/**
	 * The meta object id for the '{@link cheddar.impl.ElementImpl <em>Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.impl.ElementImpl
	 * @see cheddar.impl.CheddarPackageImpl#getElement()
	 * @generated
	 */
	int ELEMENT = 1;

	/**
	 * The number of structural features of the '<em>Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEMENT_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link cheddar.impl.DependencyElementImpl <em>Dependency Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.impl.DependencyElementImpl
	 * @see cheddar.impl.CheddarPackageImpl#getDependencyElement()
	 * @generated
	 */
	int DEPENDENCY_ELEMENT = 0;

	/**
	 * The number of structural features of the '<em>Dependency Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_ELEMENT_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link cheddar.impl.processorImpl <em>processor</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.impl.processorImpl
	 * @see cheddar.impl.CheddarPackageImpl#getprocessor()
	 * @generated
	 */
	int PROCESSOR = 2;

	/**
	 * The feature id for the '<em><b>Scheduler</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR__SCHEDULER = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Network link</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR__NETWORK_LINK = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR__NAME = ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>processor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSOR_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link cheddar.impl.schedulerImpl <em>scheduler</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.impl.schedulerImpl
	 * @see cheddar.impl.CheddarPackageImpl#getscheduler()
	 * @generated
	 */
	int SCHEDULER = 3;

	/**
	 * The feature id for the '<em><b>Is preemptive</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__IS_PREEMPTIVE = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Quantum</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__QUANTUM = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Policy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__POLICY = ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Parametric filename</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__PARAMETRIC_FILENAME = ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>scheduler</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link cheddar.impl.networkImpl <em>network</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.impl.networkImpl
	 * @see cheddar.impl.CheddarPackageImpl#getnetwork()
	 * @generated
	 */
	int NETWORK = 4;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK__VALUE = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>network</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NETWORK_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link cheddar.impl.address_spaceImpl <em>address space</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.impl.address_spaceImpl
	 * @see cheddar.impl.CheddarPackageImpl#getaddress_space()
	 * @generated
	 */
	int ADDRESS_SPACE = 5;

	/**
	 * The feature id for the '<em><b>Cpu name</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS_SPACE__CPU_NAME = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS_SPACE__NAME = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Text memory size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS_SPACE__TEXT_MEMORY_SIZE = ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Heap memory size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS_SPACE__HEAP_MEMORY_SIZE = ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Stack memory size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS_SPACE__STACK_MEMORY_SIZE = ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Data memory size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS_SPACE__DATA_MEMORY_SIZE = ELEMENT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Scheduler</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS_SPACE__SCHEDULER = ELEMENT_FEATURE_COUNT + 6;

	/**
	 * The number of structural features of the '<em>address space</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS_SPACE_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 7;

	/**
	 * The meta object id for the '{@link cheddar.impl.taskImpl <em>task</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.impl.taskImpl
	 * @see cheddar.impl.CheddarPackageImpl#gettask()
	 * @generated
	 */
	int TASK = 6;

	/**
	 * The feature id for the '<em><b>Task type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK__TASK_TYPE = DEPENDENCY_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Cpu name</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK__CPU_NAME = DEPENDENCY_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Address space name</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK__ADDRESS_SPACE_NAME = DEPENDENCY_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>X</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK__X = DEPENDENCY_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Y</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK__Y = DEPENDENCY_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK__NAME = DEPENDENCY_ELEMENT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Capacity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK__CAPACITY = DEPENDENCY_ELEMENT_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK__PERIOD = DEPENDENCY_ELEMENT_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Start time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK__START_TIME = DEPENDENCY_ELEMENT_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>Deadline</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK__DEADLINE = DEPENDENCY_ELEMENT_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>Priority</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK__PRIORITY = DEPENDENCY_ELEMENT_FEATURE_COUNT + 10;

	/**
	 * The feature id for the '<em><b>Policy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK__POLICY = DEPENDENCY_ELEMENT_FEATURE_COUNT + 11;

	/**
	 * The feature id for the '<em><b>Jitter</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK__JITTER = DEPENDENCY_ELEMENT_FEATURE_COUNT + 12;

	/**
	 * The feature id for the '<em><b>Blocking time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK__BLOCKING_TIME = DEPENDENCY_ELEMENT_FEATURE_COUNT + 13;

	/**
	 * The feature id for the '<em><b>Activation rule</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK__ACTIVATION_RULE = DEPENDENCY_ELEMENT_FEATURE_COUNT + 14;

	/**
	 * The feature id for the '<em><b>Criticality</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK__CRITICALITY = DEPENDENCY_ELEMENT_FEATURE_COUNT + 15;

	/**
	 * The feature id for the '<em><b>Seed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK__SEED = DEPENDENCY_ELEMENT_FEATURE_COUNT + 16;

	/**
	 * The feature id for the '<em><b>Predictable seed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK__PREDICTABLE_SEED = DEPENDENCY_ELEMENT_FEATURE_COUNT + 17;

	/**
	 * The feature id for the '<em><b>Text memory size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK__TEXT_MEMORY_SIZE = DEPENDENCY_ELEMENT_FEATURE_COUNT + 18;

	/**
	 * The feature id for the '<em><b>Stack memory size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK__STACK_MEMORY_SIZE = DEPENDENCY_ELEMENT_FEATURE_COUNT + 19;

	/**
	 * The feature id for the '<em><b>Offsets</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK__OFFSETS = DEPENDENCY_ELEMENT_FEATURE_COUNT + 20;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK__PARAMETERS = DEPENDENCY_ELEMENT_FEATURE_COUNT + 21;

	/**
	 * The number of structural features of the '<em>task</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK_FEATURE_COUNT = DEPENDENCY_ELEMENT_FEATURE_COUNT + 22;

	/**
	 * The meta object id for the '{@link cheddar.impl.offsetImpl <em>offset</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.impl.offsetImpl
	 * @see cheddar.impl.CheddarPackageImpl#getoffset()
	 * @generated
	 */
	int OFFSET = 7;

	/**
	 * The feature id for the '<em><b>Activation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OFFSET__ACTIVATION = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OFFSET__VALUE = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>offset</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OFFSET_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link cheddar.impl.parameterImpl <em>parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.impl.parameterImpl
	 * @see cheddar.impl.CheddarPackageImpl#getparameter()
	 * @generated
	 */
	int PARAMETER = 8;

	/**
	 * The feature id for the '<em><b>Parameter type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER__PARAMETER_TYPE = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER__NAME = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER__VALUE = ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link cheddar.impl.event_analyzerImpl <em>event analyzer</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.impl.event_analyzerImpl
	 * @see cheddar.impl.CheddarPackageImpl#getevent_analyzer()
	 * @generated
	 */
	int EVENT_ANALYZER = 9;

	/**
	 * The feature id for the '<em><b>Parametric filename</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_ANALYZER__PARAMETRIC_FILENAME = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>event analyzer</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_ANALYZER_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link cheddar.impl.bufferImpl <em>buffer</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.impl.bufferImpl
	 * @see cheddar.impl.CheddarPackageImpl#getbuffer()
	 * @generated
	 */
	int BUFFER = 10;

	/**
	 * The feature id for the '<em><b>X</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUFFER__X = DEPENDENCY_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Y</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUFFER__Y = DEPENDENCY_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Cpu name</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUFFER__CPU_NAME = DEPENDENCY_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Address space name</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUFFER__ADDRESS_SPACE_NAME = DEPENDENCY_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Buffer used by</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUFFER__BUFFER_USED_BY = DEPENDENCY_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUFFER__NAME = DEPENDENCY_ELEMENT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUFFER__SIZE = DEPENDENCY_ELEMENT_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Qs</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUFFER__QS = DEPENDENCY_ELEMENT_FEATURE_COUNT + 7;

	/**
	 * The number of structural features of the '<em>buffer</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUFFER_FEATURE_COUNT = DEPENDENCY_ELEMENT_FEATURE_COUNT + 8;

	/**
	 * The meta object id for the '{@link cheddar.impl.buffer_userImpl <em>buffer user</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.impl.buffer_userImpl
	 * @see cheddar.impl.CheddarPackageImpl#getbuffer_user()
	 * @generated
	 */
	int BUFFER_USER = 11;

	/**
	 * The feature id for the '<em><b>Buffer role</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUFFER_USER__BUFFER_ROLE = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Task name</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUFFER_USER__TASK_NAME = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUFFER_USER__TIME = ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUFFER_USER__SIZE = ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>buffer user</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUFFER_USER_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link cheddar.impl.dependencyImpl <em>dependency</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.impl.dependencyImpl
	 * @see cheddar.impl.CheddarPackageImpl#getdependency()
	 * @generated
	 */
	int DEPENDENCY = 12;

	/**
	 * The feature id for the '<em><b>To type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY__TO_TYPE = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>From type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY__FROM_TYPE = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>From</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY__FROM = ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>To</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY__TO = ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>dependency</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link cheddar.impl.messageImpl <em>message</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.impl.messageImpl
	 * @see cheddar.impl.CheddarPackageImpl#getmessage()
	 * @generated
	 */
	int MESSAGE = 13;

	/**
	 * The feature id for the '<em><b>X</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE__X = DEPENDENCY_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Y</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE__Y = DEPENDENCY_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE__NAME = DEPENDENCY_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Jitter</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE__JITTER = DEPENDENCY_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Deadline</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE__DEADLINE = DEPENDENCY_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE__PERIOD = DEPENDENCY_ELEMENT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE__SIZE = DEPENDENCY_ELEMENT_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Response time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE__RESPONSE_TIME = DEPENDENCY_ELEMENT_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Communication time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE__COMMUNICATION_TIME = DEPENDENCY_ELEMENT_FEATURE_COUNT + 8;

	/**
	 * The number of structural features of the '<em>message</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE_FEATURE_COUNT = DEPENDENCY_ELEMENT_FEATURE_COUNT + 9;

	/**
	 * The meta object id for the '{@link cheddar.impl.resource_userImpl <em>resource user</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.impl.resource_userImpl
	 * @see cheddar.impl.CheddarPackageImpl#getresource_user()
	 * @generated
	 */
	int RESOURCE_USER = 14;

	/**
	 * The feature id for the '<em><b>Task name</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_USER__TASK_NAME = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Start time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_USER__START_TIME = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>End time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_USER__END_TIME = ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>resource user</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_USER_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link cheddar.impl.resourceImpl <em>resource</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.impl.resourceImpl
	 * @see cheddar.impl.CheddarPackageImpl#getresource()
	 * @generated
	 */
	int RESOURCE = 15;

	/**
	 * The feature id for the '<em><b>Cpu name</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE__CPU_NAME = ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Address space name</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE__ADDRESS_SPACE_NAME = ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Resource used by</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE__RESOURCE_USED_BY = ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE__NAME = ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>State</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE__STATE = ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Protocol</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE__PROTOCOL = ELEMENT_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>resource</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 6;

	/**
	 * The meta object id for the '{@link cheddar.impl.RootImpl <em>Root</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.impl.RootImpl
	 * @see cheddar.impl.CheddarPackageImpl#getRoot()
	 * @generated
	 */
	int ROOT = 16;

	/**
	 * The feature id for the '<em><b>Processor</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOT__PROCESSOR = 0;

	/**
	 * The feature id for the '<em><b>Address space</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOT__ADDRESS_SPACE = 1;

	/**
	 * The feature id for the '<em><b>Task</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOT__TASK = 2;

	/**
	 * The feature id for the '<em><b>Buffer</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOT__BUFFER = 3;

	/**
	 * The feature id for the '<em><b>Message</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOT__MESSAGE = 4;

	/**
	 * The feature id for the '<em><b>Dependency</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOT__DEPENDENCY = 5;

	/**
	 * The feature id for the '<em><b>Resource</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOT__RESOURCE = 6;

	/**
	 * The feature id for the '<em><b>Event analyzer</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOT__EVENT_ANALYZER = 7;

	/**
	 * The number of structural features of the '<em>Root</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOT_FEATURE_COUNT = 8;


	/**
	 * Returns the meta object for class '{@link cheddar.DependencyElement <em>Dependency Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Dependency Element</em>'.
	 * @see cheddar.DependencyElement
	 * @generated
	 */
	EClass getDependencyElement();

	/**
	 * Returns the meta object for class '{@link cheddar.Element <em>Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Element</em>'.
	 * @see cheddar.Element
	 * @generated
	 */
	EClass getElement();

	/**
	 * Returns the meta object for class '{@link cheddar.processor <em>processor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>processor</em>'.
	 * @see cheddar.processor
	 * @generated
	 */
	EClass getprocessor();

	/**
	 * Returns the meta object for the containment reference '{@link cheddar.processor#getScheduler <em>Scheduler</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Scheduler</em>'.
	 * @see cheddar.processor#getScheduler()
	 * @see #getprocessor()
	 * @generated
	 */
	EReference getprocessor_Scheduler();

	/**
	 * Returns the meta object for the containment reference '{@link cheddar.processor#getNetwork_link <em>Network link</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Network link</em>'.
	 * @see cheddar.processor#getNetwork_link()
	 * @see #getprocessor()
	 * @generated
	 */
	EReference getprocessor_Network_link();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.processor#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see cheddar.processor#getName()
	 * @see #getprocessor()
	 * @generated
	 */
	EAttribute getprocessor_Name();

	/**
	 * Returns the meta object for class '{@link cheddar.scheduler <em>scheduler</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>scheduler</em>'.
	 * @see cheddar.scheduler
	 * @generated
	 */
	EClass getscheduler();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.scheduler#getIs_preemptive <em>Is preemptive</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is preemptive</em>'.
	 * @see cheddar.scheduler#getIs_preemptive()
	 * @see #getscheduler()
	 * @generated
	 */
	EAttribute getscheduler_Is_preemptive();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.scheduler#getQuantum <em>Quantum</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Quantum</em>'.
	 * @see cheddar.scheduler#getQuantum()
	 * @see #getscheduler()
	 * @generated
	 */
	EAttribute getscheduler_Quantum();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.scheduler#getPolicy <em>Policy</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Policy</em>'.
	 * @see cheddar.scheduler#getPolicy()
	 * @see #getscheduler()
	 * @generated
	 */
	EAttribute getscheduler_Policy();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.scheduler#getParametric_filename <em>Parametric filename</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Parametric filename</em>'.
	 * @see cheddar.scheduler#getParametric_filename()
	 * @see #getscheduler()
	 * @generated
	 */
	EAttribute getscheduler_Parametric_filename();

	/**
	 * Returns the meta object for class '{@link cheddar.network <em>network</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>network</em>'.
	 * @see cheddar.network
	 * @generated
	 */
	EClass getnetwork();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.network#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see cheddar.network#getValue()
	 * @see #getnetwork()
	 * @generated
	 */
	EAttribute getnetwork_Value();

	/**
	 * Returns the meta object for class '{@link cheddar.address_space <em>address space</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>address space</em>'.
	 * @see cheddar.address_space
	 * @generated
	 */
	EClass getaddress_space();

	/**
	 * Returns the meta object for the reference '{@link cheddar.address_space#getCpu_name <em>Cpu name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Cpu name</em>'.
	 * @see cheddar.address_space#getCpu_name()
	 * @see #getaddress_space()
	 * @generated
	 */
	EReference getaddress_space_Cpu_name();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.address_space#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see cheddar.address_space#getName()
	 * @see #getaddress_space()
	 * @generated
	 */
	EAttribute getaddress_space_Name();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.address_space#getText_memory_size <em>Text memory size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Text memory size</em>'.
	 * @see cheddar.address_space#getText_memory_size()
	 * @see #getaddress_space()
	 * @generated
	 */
	EAttribute getaddress_space_Text_memory_size();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.address_space#getHeap_memory_size <em>Heap memory size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Heap memory size</em>'.
	 * @see cheddar.address_space#getHeap_memory_size()
	 * @see #getaddress_space()
	 * @generated
	 */
	EAttribute getaddress_space_Heap_memory_size();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.address_space#getStack_memory_size <em>Stack memory size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Stack memory size</em>'.
	 * @see cheddar.address_space#getStack_memory_size()
	 * @see #getaddress_space()
	 * @generated
	 */
	EAttribute getaddress_space_Stack_memory_size();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.address_space#getData_memory_size <em>Data memory size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Data memory size</em>'.
	 * @see cheddar.address_space#getData_memory_size()
	 * @see #getaddress_space()
	 * @generated
	 */
	EAttribute getaddress_space_Data_memory_size();

	/**
	 * Returns the meta object for the containment reference '{@link cheddar.address_space#getScheduler <em>Scheduler</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Scheduler</em>'.
	 * @see cheddar.address_space#getScheduler()
	 * @see #getaddress_space()
	 * @generated
	 */
	EReference getaddress_space_Scheduler();

	/**
	 * Returns the meta object for class '{@link cheddar.task <em>task</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>task</em>'.
	 * @see cheddar.task
	 * @generated
	 */
	EClass gettask();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.task#getTask_type <em>Task type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Task type</em>'.
	 * @see cheddar.task#getTask_type()
	 * @see #gettask()
	 * @generated
	 */
	EAttribute gettask_Task_type();

	/**
	 * Returns the meta object for the reference '{@link cheddar.task#getCpu_name <em>Cpu name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Cpu name</em>'.
	 * @see cheddar.task#getCpu_name()
	 * @see #gettask()
	 * @generated
	 */
	EReference gettask_Cpu_name();

	/**
	 * Returns the meta object for the reference '{@link cheddar.task#getAddress_space_name <em>Address space name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Address space name</em>'.
	 * @see cheddar.task#getAddress_space_name()
	 * @see #gettask()
	 * @generated
	 */
	EReference gettask_Address_space_name();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.task#getX <em>X</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>X</em>'.
	 * @see cheddar.task#getX()
	 * @see #gettask()
	 * @generated
	 */
	EAttribute gettask_X();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.task#getY <em>Y</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Y</em>'.
	 * @see cheddar.task#getY()
	 * @see #gettask()
	 * @generated
	 */
	EAttribute gettask_Y();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.task#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see cheddar.task#getName()
	 * @see #gettask()
	 * @generated
	 */
	EAttribute gettask_Name();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.task#getCapacity <em>Capacity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Capacity</em>'.
	 * @see cheddar.task#getCapacity()
	 * @see #gettask()
	 * @generated
	 */
	EAttribute gettask_Capacity();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.task#getPeriod <em>Period</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Period</em>'.
	 * @see cheddar.task#getPeriod()
	 * @see #gettask()
	 * @generated
	 */
	EAttribute gettask_Period();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.task#getStart_time <em>Start time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Start time</em>'.
	 * @see cheddar.task#getStart_time()
	 * @see #gettask()
	 * @generated
	 */
	EAttribute gettask_Start_time();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.task#getDeadline <em>Deadline</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Deadline</em>'.
	 * @see cheddar.task#getDeadline()
	 * @see #gettask()
	 * @generated
	 */
	EAttribute gettask_Deadline();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.task#getPriority <em>Priority</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Priority</em>'.
	 * @see cheddar.task#getPriority()
	 * @see #gettask()
	 * @generated
	 */
	EAttribute gettask_Priority();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.task#getPolicy <em>Policy</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Policy</em>'.
	 * @see cheddar.task#getPolicy()
	 * @see #gettask()
	 * @generated
	 */
	EAttribute gettask_Policy();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.task#getJitter <em>Jitter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Jitter</em>'.
	 * @see cheddar.task#getJitter()
	 * @see #gettask()
	 * @generated
	 */
	EAttribute gettask_Jitter();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.task#getBlocking_time <em>Blocking time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Blocking time</em>'.
	 * @see cheddar.task#getBlocking_time()
	 * @see #gettask()
	 * @generated
	 */
	EAttribute gettask_Blocking_time();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.task#getActivation_rule <em>Activation rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Activation rule</em>'.
	 * @see cheddar.task#getActivation_rule()
	 * @see #gettask()
	 * @generated
	 */
	EAttribute gettask_Activation_rule();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.task#getCriticality <em>Criticality</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Criticality</em>'.
	 * @see cheddar.task#getCriticality()
	 * @see #gettask()
	 * @generated
	 */
	EAttribute gettask_Criticality();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.task#getSeed <em>Seed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Seed</em>'.
	 * @see cheddar.task#getSeed()
	 * @see #gettask()
	 * @generated
	 */
	EAttribute gettask_Seed();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.task#isPredictable_seed <em>Predictable seed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Predictable seed</em>'.
	 * @see cheddar.task#isPredictable_seed()
	 * @see #gettask()
	 * @generated
	 */
	EAttribute gettask_Predictable_seed();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.task#getText_memory_size <em>Text memory size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Text memory size</em>'.
	 * @see cheddar.task#getText_memory_size()
	 * @see #gettask()
	 * @generated
	 */
	EAttribute gettask_Text_memory_size();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.task#getStack_memory_size <em>Stack memory size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Stack memory size</em>'.
	 * @see cheddar.task#getStack_memory_size()
	 * @see #gettask()
	 * @generated
	 */
	EAttribute gettask_Stack_memory_size();

	/**
	 * Returns the meta object for the containment reference list '{@link cheddar.task#getOffsets <em>Offsets</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Offsets</em>'.
	 * @see cheddar.task#getOffsets()
	 * @see #gettask()
	 * @generated
	 */
	EReference gettask_Offsets();

	/**
	 * Returns the meta object for the containment reference list '{@link cheddar.task#getParameters <em>Parameters</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Parameters</em>'.
	 * @see cheddar.task#getParameters()
	 * @see #gettask()
	 * @generated
	 */
	EReference gettask_Parameters();

	/**
	 * Returns the meta object for class '{@link cheddar.offset <em>offset</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>offset</em>'.
	 * @see cheddar.offset
	 * @generated
	 */
	EClass getoffset();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.offset#getActivation <em>Activation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Activation</em>'.
	 * @see cheddar.offset#getActivation()
	 * @see #getoffset()
	 * @generated
	 */
	EAttribute getoffset_Activation();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.offset#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see cheddar.offset#getValue()
	 * @see #getoffset()
	 * @generated
	 */
	EAttribute getoffset_Value();

	/**
	 * Returns the meta object for class '{@link cheddar.parameter <em>parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>parameter</em>'.
	 * @see cheddar.parameter
	 * @generated
	 */
	EClass getparameter();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.parameter#getParameter_type <em>Parameter type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Parameter type</em>'.
	 * @see cheddar.parameter#getParameter_type()
	 * @see #getparameter()
	 * @generated
	 */
	EAttribute getparameter_Parameter_type();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.parameter#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see cheddar.parameter#getName()
	 * @see #getparameter()
	 * @generated
	 */
	EAttribute getparameter_Name();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.parameter#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see cheddar.parameter#getValue()
	 * @see #getparameter()
	 * @generated
	 */
	EAttribute getparameter_Value();

	/**
	 * Returns the meta object for class '{@link cheddar.event_analyzer <em>event analyzer</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>event analyzer</em>'.
	 * @see cheddar.event_analyzer
	 * @generated
	 */
	EClass getevent_analyzer();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.event_analyzer#getParametric_filename <em>Parametric filename</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Parametric filename</em>'.
	 * @see cheddar.event_analyzer#getParametric_filename()
	 * @see #getevent_analyzer()
	 * @generated
	 */
	EAttribute getevent_analyzer_Parametric_filename();

	/**
	 * Returns the meta object for class '{@link cheddar.buffer <em>buffer</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>buffer</em>'.
	 * @see cheddar.buffer
	 * @generated
	 */
	EClass getbuffer();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.buffer#getX <em>X</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>X</em>'.
	 * @see cheddar.buffer#getX()
	 * @see #getbuffer()
	 * @generated
	 */
	EAttribute getbuffer_X();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.buffer#getY <em>Y</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Y</em>'.
	 * @see cheddar.buffer#getY()
	 * @see #getbuffer()
	 * @generated
	 */
	EAttribute getbuffer_Y();

	/**
	 * Returns the meta object for the reference '{@link cheddar.buffer#getCpu_name <em>Cpu name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Cpu name</em>'.
	 * @see cheddar.buffer#getCpu_name()
	 * @see #getbuffer()
	 * @generated
	 */
	EReference getbuffer_Cpu_name();

	/**
	 * Returns the meta object for the reference '{@link cheddar.buffer#getAddress_space_name <em>Address space name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Address space name</em>'.
	 * @see cheddar.buffer#getAddress_space_name()
	 * @see #getbuffer()
	 * @generated
	 */
	EReference getbuffer_Address_space_name();

	/**
	 * Returns the meta object for the containment reference list '{@link cheddar.buffer#getBuffer_used_by <em>Buffer used by</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Buffer used by</em>'.
	 * @see cheddar.buffer#getBuffer_used_by()
	 * @see #getbuffer()
	 * @generated
	 */
	EReference getbuffer_Buffer_used_by();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.buffer#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see cheddar.buffer#getName()
	 * @see #getbuffer()
	 * @generated
	 */
	EAttribute getbuffer_Name();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.buffer#getSize <em>Size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Size</em>'.
	 * @see cheddar.buffer#getSize()
	 * @see #getbuffer()
	 * @generated
	 */
	EAttribute getbuffer_Size();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.buffer#getQs <em>Qs</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Qs</em>'.
	 * @see cheddar.buffer#getQs()
	 * @see #getbuffer()
	 * @generated
	 */
	EAttribute getbuffer_Qs();

	/**
	 * Returns the meta object for class '{@link cheddar.buffer_user <em>buffer user</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>buffer user</em>'.
	 * @see cheddar.buffer_user
	 * @generated
	 */
	EClass getbuffer_user();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.buffer_user#getBuffer_role <em>Buffer role</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Buffer role</em>'.
	 * @see cheddar.buffer_user#getBuffer_role()
	 * @see #getbuffer_user()
	 * @generated
	 */
	EAttribute getbuffer_user_Buffer_role();

	/**
	 * Returns the meta object for the reference '{@link cheddar.buffer_user#getTask_name <em>Task name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Task name</em>'.
	 * @see cheddar.buffer_user#getTask_name()
	 * @see #getbuffer_user()
	 * @generated
	 */
	EReference getbuffer_user_Task_name();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.buffer_user#getTime <em>Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Time</em>'.
	 * @see cheddar.buffer_user#getTime()
	 * @see #getbuffer_user()
	 * @generated
	 */
	EAttribute getbuffer_user_Time();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.buffer_user#getSize <em>Size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Size</em>'.
	 * @see cheddar.buffer_user#getSize()
	 * @see #getbuffer_user()
	 * @generated
	 */
	EAttribute getbuffer_user_Size();

	/**
	 * Returns the meta object for class '{@link cheddar.dependency <em>dependency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>dependency</em>'.
	 * @see cheddar.dependency
	 * @generated
	 */
	EClass getdependency();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.dependency#getTo_type <em>To type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>To type</em>'.
	 * @see cheddar.dependency#getTo_type()
	 * @see #getdependency()
	 * @generated
	 */
	EAttribute getdependency_To_type();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.dependency#getFrom_type <em>From type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>From type</em>'.
	 * @see cheddar.dependency#getFrom_type()
	 * @see #getdependency()
	 * @generated
	 */
	EAttribute getdependency_From_type();

	/**
	 * Returns the meta object for the reference '{@link cheddar.dependency#getFrom <em>From</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>From</em>'.
	 * @see cheddar.dependency#getFrom()
	 * @see #getdependency()
	 * @generated
	 */
	EReference getdependency_From();

	/**
	 * Returns the meta object for the reference '{@link cheddar.dependency#getTo <em>To</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>To</em>'.
	 * @see cheddar.dependency#getTo()
	 * @see #getdependency()
	 * @generated
	 */
	EReference getdependency_To();

	/**
	 * Returns the meta object for class '{@link cheddar.message <em>message</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>message</em>'.
	 * @see cheddar.message
	 * @generated
	 */
	EClass getmessage();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.message#getX <em>X</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>X</em>'.
	 * @see cheddar.message#getX()
	 * @see #getmessage()
	 * @generated
	 */
	EAttribute getmessage_X();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.message#getY <em>Y</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Y</em>'.
	 * @see cheddar.message#getY()
	 * @see #getmessage()
	 * @generated
	 */
	EAttribute getmessage_Y();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.message#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see cheddar.message#getName()
	 * @see #getmessage()
	 * @generated
	 */
	EAttribute getmessage_Name();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.message#getJitter <em>Jitter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Jitter</em>'.
	 * @see cheddar.message#getJitter()
	 * @see #getmessage()
	 * @generated
	 */
	EAttribute getmessage_Jitter();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.message#getDeadline <em>Deadline</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Deadline</em>'.
	 * @see cheddar.message#getDeadline()
	 * @see #getmessage()
	 * @generated
	 */
	EAttribute getmessage_Deadline();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.message#getPeriod <em>Period</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Period</em>'.
	 * @see cheddar.message#getPeriod()
	 * @see #getmessage()
	 * @generated
	 */
	EAttribute getmessage_Period();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.message#getSize <em>Size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Size</em>'.
	 * @see cheddar.message#getSize()
	 * @see #getmessage()
	 * @generated
	 */
	EAttribute getmessage_Size();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.message#getResponse_time <em>Response time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Response time</em>'.
	 * @see cheddar.message#getResponse_time()
	 * @see #getmessage()
	 * @generated
	 */
	EAttribute getmessage_Response_time();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.message#getCommunication_time <em>Communication time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Communication time</em>'.
	 * @see cheddar.message#getCommunication_time()
	 * @see #getmessage()
	 * @generated
	 */
	EAttribute getmessage_Communication_time();

	/**
	 * Returns the meta object for class '{@link cheddar.resource_user <em>resource user</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>resource user</em>'.
	 * @see cheddar.resource_user
	 * @generated
	 */
	EClass getresource_user();

	/**
	 * Returns the meta object for the reference '{@link cheddar.resource_user#getTask_name <em>Task name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Task name</em>'.
	 * @see cheddar.resource_user#getTask_name()
	 * @see #getresource_user()
	 * @generated
	 */
	EReference getresource_user_Task_name();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.resource_user#getStart_time <em>Start time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Start time</em>'.
	 * @see cheddar.resource_user#getStart_time()
	 * @see #getresource_user()
	 * @generated
	 */
	EAttribute getresource_user_Start_time();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.resource_user#getEnd_time <em>End time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>End time</em>'.
	 * @see cheddar.resource_user#getEnd_time()
	 * @see #getresource_user()
	 * @generated
	 */
	EAttribute getresource_user_End_time();

	/**
	 * Returns the meta object for class '{@link cheddar.resource <em>resource</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>resource</em>'.
	 * @see cheddar.resource
	 * @generated
	 */
	EClass getresource();

	/**
	 * Returns the meta object for the reference '{@link cheddar.resource#getCpu_name <em>Cpu name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Cpu name</em>'.
	 * @see cheddar.resource#getCpu_name()
	 * @see #getresource()
	 * @generated
	 */
	EReference getresource_Cpu_name();

	/**
	 * Returns the meta object for the reference '{@link cheddar.resource#getAddress_space_name <em>Address space name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Address space name</em>'.
	 * @see cheddar.resource#getAddress_space_name()
	 * @see #getresource()
	 * @generated
	 */
	EReference getresource_Address_space_name();

	/**
	 * Returns the meta object for the containment reference list '{@link cheddar.resource#getResource_used_by <em>Resource used by</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Resource used by</em>'.
	 * @see cheddar.resource#getResource_used_by()
	 * @see #getresource()
	 * @generated
	 */
	EReference getresource_Resource_used_by();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.resource#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see cheddar.resource#getName()
	 * @see #getresource()
	 * @generated
	 */
	EAttribute getresource_Name();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.resource#getState <em>State</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>State</em>'.
	 * @see cheddar.resource#getState()
	 * @see #getresource()
	 * @generated
	 */
	EAttribute getresource_State();

	/**
	 * Returns the meta object for the attribute '{@link cheddar.resource#getProtocol <em>Protocol</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Protocol</em>'.
	 * @see cheddar.resource#getProtocol()
	 * @see #getresource()
	 * @generated
	 */
	EAttribute getresource_Protocol();

	/**
	 * Returns the meta object for class '{@link cheddar.Root <em>Root</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Root</em>'.
	 * @see cheddar.Root
	 * @generated
	 */
	EClass getRoot();

	/**
	 * Returns the meta object for the containment reference list '{@link cheddar.Root#getProcessor <em>Processor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Processor</em>'.
	 * @see cheddar.Root#getProcessor()
	 * @see #getRoot()
	 * @generated
	 */
	EReference getRoot_Processor();

	/**
	 * Returns the meta object for the containment reference list '{@link cheddar.Root#getAddress_space <em>Address space</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Address space</em>'.
	 * @see cheddar.Root#getAddress_space()
	 * @see #getRoot()
	 * @generated
	 */
	EReference getRoot_Address_space();

	/**
	 * Returns the meta object for the containment reference list '{@link cheddar.Root#getTask <em>Task</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Task</em>'.
	 * @see cheddar.Root#getTask()
	 * @see #getRoot()
	 * @generated
	 */
	EReference getRoot_Task();

	/**
	 * Returns the meta object for the containment reference list '{@link cheddar.Root#getBuffer <em>Buffer</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Buffer</em>'.
	 * @see cheddar.Root#getBuffer()
	 * @see #getRoot()
	 * @generated
	 */
	EReference getRoot_Buffer();

	/**
	 * Returns the meta object for the containment reference list '{@link cheddar.Root#getMessage <em>Message</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Message</em>'.
	 * @see cheddar.Root#getMessage()
	 * @see #getRoot()
	 * @generated
	 */
	EReference getRoot_Message();

	/**
	 * Returns the meta object for the containment reference list '{@link cheddar.Root#getDependency <em>Dependency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Dependency</em>'.
	 * @see cheddar.Root#getDependency()
	 * @see #getRoot()
	 * @generated
	 */
	EReference getRoot_Dependency();

	/**
	 * Returns the meta object for the containment reference list '{@link cheddar.Root#getResource <em>Resource</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Resource</em>'.
	 * @see cheddar.Root#getResource()
	 * @see #getRoot()
	 * @generated
	 */
	EReference getRoot_Resource();

	/**
	 * Returns the meta object for the containment reference list '{@link cheddar.Root#getEvent_analyzer <em>Event analyzer</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Event analyzer</em>'.
	 * @see cheddar.Root#getEvent_analyzer()
	 * @see #getRoot()
	 * @generated
	 */
	EReference getRoot_Event_analyzer();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	CheddarFactory getCheddarFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals  {
		/**
		 * The meta object literal for the '{@link cheddar.impl.DependencyElementImpl <em>Dependency Element</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.impl.DependencyElementImpl
		 * @see cheddar.impl.CheddarPackageImpl#getDependencyElement()
		 * @generated
		 */
		EClass DEPENDENCY_ELEMENT = eINSTANCE.getDependencyElement();

		/**
		 * The meta object literal for the '{@link cheddar.impl.ElementImpl <em>Element</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.impl.ElementImpl
		 * @see cheddar.impl.CheddarPackageImpl#getElement()
		 * @generated
		 */
		EClass ELEMENT = eINSTANCE.getElement();

		/**
		 * The meta object literal for the '{@link cheddar.impl.processorImpl <em>processor</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.impl.processorImpl
		 * @see cheddar.impl.CheddarPackageImpl#getprocessor()
		 * @generated
		 */
		EClass PROCESSOR = eINSTANCE.getprocessor();

		/**
		 * The meta object literal for the '<em><b>Scheduler</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROCESSOR__SCHEDULER = eINSTANCE.getprocessor_Scheduler();

		/**
		 * The meta object literal for the '<em><b>Network link</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROCESSOR__NETWORK_LINK = eINSTANCE.getprocessor_Network_link();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROCESSOR__NAME = eINSTANCE.getprocessor_Name();

		/**
		 * The meta object literal for the '{@link cheddar.impl.schedulerImpl <em>scheduler</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.impl.schedulerImpl
		 * @see cheddar.impl.CheddarPackageImpl#getscheduler()
		 * @generated
		 */
		EClass SCHEDULER = eINSTANCE.getscheduler();

		/**
		 * The meta object literal for the '<em><b>Is preemptive</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SCHEDULER__IS_PREEMPTIVE = eINSTANCE.getscheduler_Is_preemptive();

		/**
		 * The meta object literal for the '<em><b>Quantum</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SCHEDULER__QUANTUM = eINSTANCE.getscheduler_Quantum();

		/**
		 * The meta object literal for the '<em><b>Policy</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SCHEDULER__POLICY = eINSTANCE.getscheduler_Policy();

		/**
		 * The meta object literal for the '<em><b>Parametric filename</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SCHEDULER__PARAMETRIC_FILENAME = eINSTANCE.getscheduler_Parametric_filename();

		/**
		 * The meta object literal for the '{@link cheddar.impl.networkImpl <em>network</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.impl.networkImpl
		 * @see cheddar.impl.CheddarPackageImpl#getnetwork()
		 * @generated
		 */
		EClass NETWORK = eINSTANCE.getnetwork();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NETWORK__VALUE = eINSTANCE.getnetwork_Value();

		/**
		 * The meta object literal for the '{@link cheddar.impl.address_spaceImpl <em>address space</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.impl.address_spaceImpl
		 * @see cheddar.impl.CheddarPackageImpl#getaddress_space()
		 * @generated
		 */
		EClass ADDRESS_SPACE = eINSTANCE.getaddress_space();

		/**
		 * The meta object literal for the '<em><b>Cpu name</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADDRESS_SPACE__CPU_NAME = eINSTANCE.getaddress_space_Cpu_name();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ADDRESS_SPACE__NAME = eINSTANCE.getaddress_space_Name();

		/**
		 * The meta object literal for the '<em><b>Text memory size</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ADDRESS_SPACE__TEXT_MEMORY_SIZE = eINSTANCE.getaddress_space_Text_memory_size();

		/**
		 * The meta object literal for the '<em><b>Heap memory size</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ADDRESS_SPACE__HEAP_MEMORY_SIZE = eINSTANCE.getaddress_space_Heap_memory_size();

		/**
		 * The meta object literal for the '<em><b>Stack memory size</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ADDRESS_SPACE__STACK_MEMORY_SIZE = eINSTANCE.getaddress_space_Stack_memory_size();

		/**
		 * The meta object literal for the '<em><b>Data memory size</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ADDRESS_SPACE__DATA_MEMORY_SIZE = eINSTANCE.getaddress_space_Data_memory_size();

		/**
		 * The meta object literal for the '<em><b>Scheduler</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADDRESS_SPACE__SCHEDULER = eINSTANCE.getaddress_space_Scheduler();

		/**
		 * The meta object literal for the '{@link cheddar.impl.taskImpl <em>task</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.impl.taskImpl
		 * @see cheddar.impl.CheddarPackageImpl#gettask()
		 * @generated
		 */
		EClass TASK = eINSTANCE.gettask();

		/**
		 * The meta object literal for the '<em><b>Task type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TASK__TASK_TYPE = eINSTANCE.gettask_Task_type();

		/**
		 * The meta object literal for the '<em><b>Cpu name</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TASK__CPU_NAME = eINSTANCE.gettask_Cpu_name();

		/**
		 * The meta object literal for the '<em><b>Address space name</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TASK__ADDRESS_SPACE_NAME = eINSTANCE.gettask_Address_space_name();

		/**
		 * The meta object literal for the '<em><b>X</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TASK__X = eINSTANCE.gettask_X();

		/**
		 * The meta object literal for the '<em><b>Y</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TASK__Y = eINSTANCE.gettask_Y();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TASK__NAME = eINSTANCE.gettask_Name();

		/**
		 * The meta object literal for the '<em><b>Capacity</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TASK__CAPACITY = eINSTANCE.gettask_Capacity();

		/**
		 * The meta object literal for the '<em><b>Period</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TASK__PERIOD = eINSTANCE.gettask_Period();

		/**
		 * The meta object literal for the '<em><b>Start time</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TASK__START_TIME = eINSTANCE.gettask_Start_time();

		/**
		 * The meta object literal for the '<em><b>Deadline</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TASK__DEADLINE = eINSTANCE.gettask_Deadline();

		/**
		 * The meta object literal for the '<em><b>Priority</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TASK__PRIORITY = eINSTANCE.gettask_Priority();

		/**
		 * The meta object literal for the '<em><b>Policy</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TASK__POLICY = eINSTANCE.gettask_Policy();

		/**
		 * The meta object literal for the '<em><b>Jitter</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TASK__JITTER = eINSTANCE.gettask_Jitter();

		/**
		 * The meta object literal for the '<em><b>Blocking time</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TASK__BLOCKING_TIME = eINSTANCE.gettask_Blocking_time();

		/**
		 * The meta object literal for the '<em><b>Activation rule</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TASK__ACTIVATION_RULE = eINSTANCE.gettask_Activation_rule();

		/**
		 * The meta object literal for the '<em><b>Criticality</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TASK__CRITICALITY = eINSTANCE.gettask_Criticality();

		/**
		 * The meta object literal for the '<em><b>Seed</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TASK__SEED = eINSTANCE.gettask_Seed();

		/**
		 * The meta object literal for the '<em><b>Predictable seed</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TASK__PREDICTABLE_SEED = eINSTANCE.gettask_Predictable_seed();

		/**
		 * The meta object literal for the '<em><b>Text memory size</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TASK__TEXT_MEMORY_SIZE = eINSTANCE.gettask_Text_memory_size();

		/**
		 * The meta object literal for the '<em><b>Stack memory size</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TASK__STACK_MEMORY_SIZE = eINSTANCE.gettask_Stack_memory_size();

		/**
		 * The meta object literal for the '<em><b>Offsets</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TASK__OFFSETS = eINSTANCE.gettask_Offsets();

		/**
		 * The meta object literal for the '<em><b>Parameters</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TASK__PARAMETERS = eINSTANCE.gettask_Parameters();

		/**
		 * The meta object literal for the '{@link cheddar.impl.offsetImpl <em>offset</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.impl.offsetImpl
		 * @see cheddar.impl.CheddarPackageImpl#getoffset()
		 * @generated
		 */
		EClass OFFSET = eINSTANCE.getoffset();

		/**
		 * The meta object literal for the '<em><b>Activation</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OFFSET__ACTIVATION = eINSTANCE.getoffset_Activation();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OFFSET__VALUE = eINSTANCE.getoffset_Value();

		/**
		 * The meta object literal for the '{@link cheddar.impl.parameterImpl <em>parameter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.impl.parameterImpl
		 * @see cheddar.impl.CheddarPackageImpl#getparameter()
		 * @generated
		 */
		EClass PARAMETER = eINSTANCE.getparameter();

		/**
		 * The meta object literal for the '<em><b>Parameter type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PARAMETER__PARAMETER_TYPE = eINSTANCE.getparameter_Parameter_type();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PARAMETER__NAME = eINSTANCE.getparameter_Name();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PARAMETER__VALUE = eINSTANCE.getparameter_Value();

		/**
		 * The meta object literal for the '{@link cheddar.impl.event_analyzerImpl <em>event analyzer</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.impl.event_analyzerImpl
		 * @see cheddar.impl.CheddarPackageImpl#getevent_analyzer()
		 * @generated
		 */
		EClass EVENT_ANALYZER = eINSTANCE.getevent_analyzer();

		/**
		 * The meta object literal for the '<em><b>Parametric filename</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EVENT_ANALYZER__PARAMETRIC_FILENAME = eINSTANCE.getevent_analyzer_Parametric_filename();

		/**
		 * The meta object literal for the '{@link cheddar.impl.bufferImpl <em>buffer</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.impl.bufferImpl
		 * @see cheddar.impl.CheddarPackageImpl#getbuffer()
		 * @generated
		 */
		EClass BUFFER = eINSTANCE.getbuffer();

		/**
		 * The meta object literal for the '<em><b>X</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BUFFER__X = eINSTANCE.getbuffer_X();

		/**
		 * The meta object literal for the '<em><b>Y</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BUFFER__Y = eINSTANCE.getbuffer_Y();

		/**
		 * The meta object literal for the '<em><b>Cpu name</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BUFFER__CPU_NAME = eINSTANCE.getbuffer_Cpu_name();

		/**
		 * The meta object literal for the '<em><b>Address space name</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BUFFER__ADDRESS_SPACE_NAME = eINSTANCE.getbuffer_Address_space_name();

		/**
		 * The meta object literal for the '<em><b>Buffer used by</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BUFFER__BUFFER_USED_BY = eINSTANCE.getbuffer_Buffer_used_by();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BUFFER__NAME = eINSTANCE.getbuffer_Name();

		/**
		 * The meta object literal for the '<em><b>Size</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BUFFER__SIZE = eINSTANCE.getbuffer_Size();

		/**
		 * The meta object literal for the '<em><b>Qs</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BUFFER__QS = eINSTANCE.getbuffer_Qs();

		/**
		 * The meta object literal for the '{@link cheddar.impl.buffer_userImpl <em>buffer user</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.impl.buffer_userImpl
		 * @see cheddar.impl.CheddarPackageImpl#getbuffer_user()
		 * @generated
		 */
		EClass BUFFER_USER = eINSTANCE.getbuffer_user();

		/**
		 * The meta object literal for the '<em><b>Buffer role</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BUFFER_USER__BUFFER_ROLE = eINSTANCE.getbuffer_user_Buffer_role();

		/**
		 * The meta object literal for the '<em><b>Task name</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BUFFER_USER__TASK_NAME = eINSTANCE.getbuffer_user_Task_name();

		/**
		 * The meta object literal for the '<em><b>Time</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BUFFER_USER__TIME = eINSTANCE.getbuffer_user_Time();

		/**
		 * The meta object literal for the '<em><b>Size</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BUFFER_USER__SIZE = eINSTANCE.getbuffer_user_Size();

		/**
		 * The meta object literal for the '{@link cheddar.impl.dependencyImpl <em>dependency</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.impl.dependencyImpl
		 * @see cheddar.impl.CheddarPackageImpl#getdependency()
		 * @generated
		 */
		EClass DEPENDENCY = eINSTANCE.getdependency();

		/**
		 * The meta object literal for the '<em><b>To type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DEPENDENCY__TO_TYPE = eINSTANCE.getdependency_To_type();

		/**
		 * The meta object literal for the '<em><b>From type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DEPENDENCY__FROM_TYPE = eINSTANCE.getdependency_From_type();

		/**
		 * The meta object literal for the '<em><b>From</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DEPENDENCY__FROM = eINSTANCE.getdependency_From();

		/**
		 * The meta object literal for the '<em><b>To</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DEPENDENCY__TO = eINSTANCE.getdependency_To();

		/**
		 * The meta object literal for the '{@link cheddar.impl.messageImpl <em>message</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.impl.messageImpl
		 * @see cheddar.impl.CheddarPackageImpl#getmessage()
		 * @generated
		 */
		EClass MESSAGE = eINSTANCE.getmessage();

		/**
		 * The meta object literal for the '<em><b>X</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MESSAGE__X = eINSTANCE.getmessage_X();

		/**
		 * The meta object literal for the '<em><b>Y</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MESSAGE__Y = eINSTANCE.getmessage_Y();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MESSAGE__NAME = eINSTANCE.getmessage_Name();

		/**
		 * The meta object literal for the '<em><b>Jitter</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MESSAGE__JITTER = eINSTANCE.getmessage_Jitter();

		/**
		 * The meta object literal for the '<em><b>Deadline</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MESSAGE__DEADLINE = eINSTANCE.getmessage_Deadline();

		/**
		 * The meta object literal for the '<em><b>Period</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MESSAGE__PERIOD = eINSTANCE.getmessage_Period();

		/**
		 * The meta object literal for the '<em><b>Size</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MESSAGE__SIZE = eINSTANCE.getmessage_Size();

		/**
		 * The meta object literal for the '<em><b>Response time</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MESSAGE__RESPONSE_TIME = eINSTANCE.getmessage_Response_time();

		/**
		 * The meta object literal for the '<em><b>Communication time</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MESSAGE__COMMUNICATION_TIME = eINSTANCE.getmessage_Communication_time();

		/**
		 * The meta object literal for the '{@link cheddar.impl.resource_userImpl <em>resource user</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.impl.resource_userImpl
		 * @see cheddar.impl.CheddarPackageImpl#getresource_user()
		 * @generated
		 */
		EClass RESOURCE_USER = eINSTANCE.getresource_user();

		/**
		 * The meta object literal for the '<em><b>Task name</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RESOURCE_USER__TASK_NAME = eINSTANCE.getresource_user_Task_name();

		/**
		 * The meta object literal for the '<em><b>Start time</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RESOURCE_USER__START_TIME = eINSTANCE.getresource_user_Start_time();

		/**
		 * The meta object literal for the '<em><b>End time</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RESOURCE_USER__END_TIME = eINSTANCE.getresource_user_End_time();

		/**
		 * The meta object literal for the '{@link cheddar.impl.resourceImpl <em>resource</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.impl.resourceImpl
		 * @see cheddar.impl.CheddarPackageImpl#getresource()
		 * @generated
		 */
		EClass RESOURCE = eINSTANCE.getresource();

		/**
		 * The meta object literal for the '<em><b>Cpu name</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RESOURCE__CPU_NAME = eINSTANCE.getresource_Cpu_name();

		/**
		 * The meta object literal for the '<em><b>Address space name</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RESOURCE__ADDRESS_SPACE_NAME = eINSTANCE.getresource_Address_space_name();

		/**
		 * The meta object literal for the '<em><b>Resource used by</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RESOURCE__RESOURCE_USED_BY = eINSTANCE.getresource_Resource_used_by();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RESOURCE__NAME = eINSTANCE.getresource_Name();

		/**
		 * The meta object literal for the '<em><b>State</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RESOURCE__STATE = eINSTANCE.getresource_State();

		/**
		 * The meta object literal for the '<em><b>Protocol</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RESOURCE__PROTOCOL = eINSTANCE.getresource_Protocol();

		/**
		 * The meta object literal for the '{@link cheddar.impl.RootImpl <em>Root</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.impl.RootImpl
		 * @see cheddar.impl.CheddarPackageImpl#getRoot()
		 * @generated
		 */
		EClass ROOT = eINSTANCE.getRoot();

		/**
		 * The meta object literal for the '<em><b>Processor</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROOT__PROCESSOR = eINSTANCE.getRoot_Processor();

		/**
		 * The meta object literal for the '<em><b>Address space</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROOT__ADDRESS_SPACE = eINSTANCE.getRoot_Address_space();

		/**
		 * The meta object literal for the '<em><b>Task</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROOT__TASK = eINSTANCE.getRoot_Task();

		/**
		 * The meta object literal for the '<em><b>Buffer</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROOT__BUFFER = eINSTANCE.getRoot_Buffer();

		/**
		 * The meta object literal for the '<em><b>Message</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROOT__MESSAGE = eINSTANCE.getRoot_Message();

		/**
		 * The meta object literal for the '<em><b>Dependency</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROOT__DEPENDENCY = eINSTANCE.getRoot_Dependency();

		/**
		 * The meta object literal for the '<em><b>Resource</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROOT__RESOURCE = eINSTANCE.getRoot_Resource();

		/**
		 * The meta object literal for the '<em><b>Event analyzer</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROOT__EVENT_ANALYZER = eINSTANCE.getRoot_Event_analyzer();

	}

} //CheddarPackage
