/**
 * <copyright>
 * Thales MARTE To Cheddar(Copyright (c) THALES 2007 All rights reserved)
 * is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published
 * in http://www.eclipse.org/legal/epl-v10.html
 * Thales MARTE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Eclipse Public License for more details.
 * </copyright>
 *
 * $Id: LibraryPackage.java,v 1.1 2008/01/23 16:59:01 emaes Exp $
 */
package cheddar.Library;

import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see cheddar.Library.LibraryFactory
 * @model kind="package"
 * @generated
 */
public interface LibraryPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "Library";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http:///cheddar/Library.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "cheddar.Library";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	LibraryPackage eINSTANCE = cheddar.Library.impl.LibraryPackageImpl.init();

	/**
	 * The meta object id for the '{@link cheddar.Library.task_type_kind <em>task type kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.Library.task_type_kind
	 * @see cheddar.Library.impl.LibraryPackageImpl#gettask_type_kind()
	 * @generated
	 */
	int TASK_TYPE_KIND = 0;

	/**
	 * The meta object id for the '{@link cheddar.Library.parameter_type_kind <em>parameter type kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.Library.parameter_type_kind
	 * @see cheddar.Library.impl.LibraryPackageImpl#getparameter_type_kind()
	 * @generated
	 */
	int PARAMETER_TYPE_KIND = 1;

	/**
	 * The meta object id for the '{@link cheddar.Library.buffer_role_kind <em>buffer role kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.Library.buffer_role_kind
	 * @see cheddar.Library.impl.LibraryPackageImpl#getbuffer_role_kind()
	 * @generated
	 */
	int BUFFER_ROLE_KIND = 2;

	/**
	 * The meta object id for the '{@link cheddar.Library.to_from_type_kind <em>to from type kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.Library.to_from_type_kind
	 * @see cheddar.Library.impl.LibraryPackageImpl#getto_from_type_kind()
	 * @generated
	 */
	int TO_FROM_TYPE_KIND = 3;

	/**
	 * The meta object id for the '{@link cheddar.Library.policy_kind <em>policy kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.Library.policy_kind
	 * @see cheddar.Library.impl.LibraryPackageImpl#getpolicy_kind()
	 * @generated
	 */
	int POLICY_KIND = 4;

	/**
	 * The meta object id for the '{@link cheddar.Library.protocol_kind <em>protocol kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.Library.protocol_kind
	 * @see cheddar.Library.impl.LibraryPackageImpl#getprotocol_kind()
	 * @generated
	 */
	int PROTOCOL_KIND = 5;

	/**
	 * The meta object id for the '{@link cheddar.Library.task_policy_kind <em>task policy kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.Library.task_policy_kind
	 * @see cheddar.Library.impl.LibraryPackageImpl#gettask_policy_kind()
	 * @generated
	 */
	int TASK_POLICY_KIND = 6;

	/**
	 * The meta object id for the '{@link cheddar.Library.qs_kind <em>qs kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.Library.qs_kind
	 * @see cheddar.Library.impl.LibraryPackageImpl#getqs_kind()
	 * @generated
	 */
	int QS_KIND = 7;

	/**
	 * The meta object id for the '{@link cheddar.Library.is_preemptive_kind <em>is preemptive kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cheddar.Library.is_preemptive_kind
	 * @see cheddar.Library.impl.LibraryPackageImpl#getis_preemptive_kind()
	 * @generated
	 */
	int IS_PREEMPTIVE_KIND = 8;


	/**
	 * Returns the meta object for enum '{@link cheddar.Library.task_type_kind <em>task type kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>task type kind</em>'.
	 * @see cheddar.Library.task_type_kind
	 * @generated
	 */
	EEnum gettask_type_kind();

	/**
	 * Returns the meta object for enum '{@link cheddar.Library.parameter_type_kind <em>parameter type kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>parameter type kind</em>'.
	 * @see cheddar.Library.parameter_type_kind
	 * @generated
	 */
	EEnum getparameter_type_kind();

	/**
	 * Returns the meta object for enum '{@link cheddar.Library.buffer_role_kind <em>buffer role kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>buffer role kind</em>'.
	 * @see cheddar.Library.buffer_role_kind
	 * @generated
	 */
	EEnum getbuffer_role_kind();

	/**
	 * Returns the meta object for enum '{@link cheddar.Library.to_from_type_kind <em>to from type kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>to from type kind</em>'.
	 * @see cheddar.Library.to_from_type_kind
	 * @generated
	 */
	EEnum getto_from_type_kind();

	/**
	 * Returns the meta object for enum '{@link cheddar.Library.policy_kind <em>policy kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>policy kind</em>'.
	 * @see cheddar.Library.policy_kind
	 * @generated
	 */
	EEnum getpolicy_kind();

	/**
	 * Returns the meta object for enum '{@link cheddar.Library.protocol_kind <em>protocol kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>protocol kind</em>'.
	 * @see cheddar.Library.protocol_kind
	 * @generated
	 */
	EEnum getprotocol_kind();

	/**
	 * Returns the meta object for enum '{@link cheddar.Library.task_policy_kind <em>task policy kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>task policy kind</em>'.
	 * @see cheddar.Library.task_policy_kind
	 * @generated
	 */
	EEnum gettask_policy_kind();

	/**
	 * Returns the meta object for enum '{@link cheddar.Library.qs_kind <em>qs kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>qs kind</em>'.
	 * @see cheddar.Library.qs_kind
	 * @generated
	 */
	EEnum getqs_kind();

	/**
	 * Returns the meta object for enum '{@link cheddar.Library.is_preemptive_kind <em>is preemptive kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>is preemptive kind</em>'.
	 * @see cheddar.Library.is_preemptive_kind
	 * @generated
	 */
	EEnum getis_preemptive_kind();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	LibraryFactory getLibraryFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link cheddar.Library.task_type_kind <em>task type kind</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.Library.task_type_kind
		 * @see cheddar.Library.impl.LibraryPackageImpl#gettask_type_kind()
		 * @generated
		 */
		EEnum TASK_TYPE_KIND = eINSTANCE.gettask_type_kind();

		/**
		 * The meta object literal for the '{@link cheddar.Library.parameter_type_kind <em>parameter type kind</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.Library.parameter_type_kind
		 * @see cheddar.Library.impl.LibraryPackageImpl#getparameter_type_kind()
		 * @generated
		 */
		EEnum PARAMETER_TYPE_KIND = eINSTANCE.getparameter_type_kind();

		/**
		 * The meta object literal for the '{@link cheddar.Library.buffer_role_kind <em>buffer role kind</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.Library.buffer_role_kind
		 * @see cheddar.Library.impl.LibraryPackageImpl#getbuffer_role_kind()
		 * @generated
		 */
		EEnum BUFFER_ROLE_KIND = eINSTANCE.getbuffer_role_kind();

		/**
		 * The meta object literal for the '{@link cheddar.Library.to_from_type_kind <em>to from type kind</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.Library.to_from_type_kind
		 * @see cheddar.Library.impl.LibraryPackageImpl#getto_from_type_kind()
		 * @generated
		 */
		EEnum TO_FROM_TYPE_KIND = eINSTANCE.getto_from_type_kind();

		/**
		 * The meta object literal for the '{@link cheddar.Library.policy_kind <em>policy kind</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.Library.policy_kind
		 * @see cheddar.Library.impl.LibraryPackageImpl#getpolicy_kind()
		 * @generated
		 */
		EEnum POLICY_KIND = eINSTANCE.getpolicy_kind();

		/**
		 * The meta object literal for the '{@link cheddar.Library.protocol_kind <em>protocol kind</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.Library.protocol_kind
		 * @see cheddar.Library.impl.LibraryPackageImpl#getprotocol_kind()
		 * @generated
		 */
		EEnum PROTOCOL_KIND = eINSTANCE.getprotocol_kind();

		/**
		 * The meta object literal for the '{@link cheddar.Library.task_policy_kind <em>task policy kind</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.Library.task_policy_kind
		 * @see cheddar.Library.impl.LibraryPackageImpl#gettask_policy_kind()
		 * @generated
		 */
		EEnum TASK_POLICY_KIND = eINSTANCE.gettask_policy_kind();

		/**
		 * The meta object literal for the '{@link cheddar.Library.qs_kind <em>qs kind</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.Library.qs_kind
		 * @see cheddar.Library.impl.LibraryPackageImpl#getqs_kind()
		 * @generated
		 */
		EEnum QS_KIND = eINSTANCE.getqs_kind();

		/**
		 * The meta object literal for the '{@link cheddar.Library.is_preemptive_kind <em>is preemptive kind</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see cheddar.Library.is_preemptive_kind
		 * @see cheddar.Library.impl.LibraryPackageImpl#getis_preemptive_kind()
		 * @generated
		 */
		EEnum IS_PREEMPTIVE_KIND = eINSTANCE.getis_preemptive_kind();

	}

} //LibraryPackage
