/**
 * <copyright>
 * Thales MARTE To Cheddar(Copyright (c) THALES 2007 All rights reserved)
 * is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published
 * in http://www.eclipse.org/legal/epl-v10.html
 * Thales MARTE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Eclipse Public License for more details.
 * </copyright>
 *
 * $Id: LibraryPackageImpl.java,v 1.1 2008/01/23 16:59:01 emaes Exp $
 */
package cheddar.Library.impl;

import cheddar.CheddarPackage;

import cheddar.Library.LibraryFactory;
import cheddar.Library.LibraryPackage;
import cheddar.Library.buffer_role_kind;
import cheddar.Library.is_preemptive_kind;
import cheddar.Library.parameter_type_kind;
import cheddar.Library.policy_kind;
import cheddar.Library.protocol_kind;
import cheddar.Library.qs_kind;
import cheddar.Library.task_policy_kind;
import cheddar.Library.task_type_kind;
import cheddar.Library.to_from_type_kind;

import cheddar.impl.CheddarPackageImpl;

import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class LibraryPackageImpl extends EPackageImpl implements LibraryPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum task_type_kindEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum parameter_type_kindEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum buffer_role_kindEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum to_from_type_kindEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum policy_kindEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum protocol_kindEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum task_policy_kindEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum qs_kindEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum is_preemptive_kindEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see cheddar.Library.LibraryPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private LibraryPackageImpl() {
		super(eNS_URI, LibraryFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this
	 * model, and for any others upon which it depends.  Simple
	 * dependencies are satisfied by calling this method on all
	 * dependent packages before doing anything else.  This method drives
	 * initialization for interdependent packages directly, in parallel
	 * with this package, itself.
	 * <p>Of this package and its interdependencies, all packages which
	 * have not yet been registered by their URI values are first created
	 * and registered.  The packages are then initialized in two steps:
	 * meta-model objects for all of the packages are created before any
	 * are initialized, since one package's meta-model objects may refer to
	 * those of another.
	 * <p>Invocation of this method will not affect any packages that have
	 * already been initialized.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static LibraryPackage init() {
		if (isInited) return (LibraryPackage)EPackage.Registry.INSTANCE.getEPackage(LibraryPackage.eNS_URI);

		// Obtain or create and register package
		LibraryPackageImpl theLibraryPackage = (LibraryPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(eNS_URI) instanceof LibraryPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(eNS_URI) : new LibraryPackageImpl());

		isInited = true;

		// Obtain or create and register interdependencies
		CheddarPackageImpl theCheddarPackage = (CheddarPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CheddarPackage.eNS_URI) instanceof CheddarPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CheddarPackage.eNS_URI) : CheddarPackage.eINSTANCE);

		// Create package meta-data objects
		theLibraryPackage.createPackageContents();
		theCheddarPackage.createPackageContents();

		// Initialize created meta-data
		theLibraryPackage.initializePackageContents();
		theCheddarPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theLibraryPackage.freeze();

		return theLibraryPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum gettask_type_kind() {
		return task_type_kindEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getparameter_type_kind() {
		return parameter_type_kindEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getbuffer_role_kind() {
		return buffer_role_kindEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getto_from_type_kind() {
		return to_from_type_kindEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getpolicy_kind() {
		return policy_kindEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getprotocol_kind() {
		return protocol_kindEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum gettask_policy_kind() {
		return task_policy_kindEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getqs_kind() {
		return qs_kindEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getis_preemptive_kind() {
		return is_preemptive_kindEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LibraryFactory getLibraryFactory() {
		return (LibraryFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create enums
		task_type_kindEEnum = createEEnum(TASK_TYPE_KIND);
		parameter_type_kindEEnum = createEEnum(PARAMETER_TYPE_KIND);
		buffer_role_kindEEnum = createEEnum(BUFFER_ROLE_KIND);
		to_from_type_kindEEnum = createEEnum(TO_FROM_TYPE_KIND);
		policy_kindEEnum = createEEnum(POLICY_KIND);
		protocol_kindEEnum = createEEnum(PROTOCOL_KIND);
		task_policy_kindEEnum = createEEnum(TASK_POLICY_KIND);
		qs_kindEEnum = createEEnum(QS_KIND);
		is_preemptive_kindEEnum = createEEnum(IS_PREEMPTIVE_KIND);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Initialize enums and add enum literals
		initEEnum(task_type_kindEEnum, task_type_kind.class, "task_type_kind");
		addEEnumLiteral(task_type_kindEEnum, task_type_kind.PERIODIC_TYPE_LITERAL);
		addEEnumLiteral(task_type_kindEEnum, task_type_kind.PARAMETRIC_TYPE_LITERAL);
		addEEnumLiteral(task_type_kindEEnum, task_type_kind.APERIODIC_TYPE_LITERAL);
		addEEnumLiteral(task_type_kindEEnum, task_type_kind.SPORADIC_TYPE_LITERAL);
		addEEnumLiteral(task_type_kindEEnum, task_type_kind.POISSON_TYPE_LITERAL);

		initEEnum(parameter_type_kindEEnum, parameter_type_kind.class, "parameter_type_kind");
		addEEnumLiteral(parameter_type_kindEEnum, parameter_type_kind.INTEGER_LITERAL);
		addEEnumLiteral(parameter_type_kindEEnum, parameter_type_kind.DOUBLE_LITERAL);
		addEEnumLiteral(parameter_type_kindEEnum, parameter_type_kind.STRING_LITERAL);
		addEEnumLiteral(parameter_type_kindEEnum, parameter_type_kind.BOOLEAN_LITERAL);

		initEEnum(buffer_role_kindEEnum, buffer_role_kind.class, "buffer_role_kind");
		addEEnumLiteral(buffer_role_kindEEnum, buffer_role_kind.CONSUMER_LITERAL);
		addEEnumLiteral(buffer_role_kindEEnum, buffer_role_kind.PRODUCER_LITERAL);

		initEEnum(to_from_type_kindEEnum, to_from_type_kind.class, "to_from_type_kind");
		addEEnumLiteral(to_from_type_kindEEnum, to_from_type_kind.BUFFER_LITERAL);
		addEEnumLiteral(to_from_type_kindEEnum, to_from_type_kind.MESSAGE_LITERAL);
		addEEnumLiteral(to_from_type_kindEEnum, to_from_type_kind.TASK_LITERAL);

		initEEnum(policy_kindEEnum, policy_kind.class, "policy_kind");
		addEEnumLiteral(policy_kindEEnum, policy_kind.EARLIEST_DEADLINE_FIRST_PROTOCOL_LITERAL);
		addEEnumLiteral(policy_kindEEnum, policy_kind.LEAST_LAXITY_FIRST_PROTOCOL_LITERAL);
		addEEnumLiteral(policy_kindEEnum, policy_kind.RATE_MONOTONIC_PROTOCOL_LITERAL);
		addEEnumLiteral(policy_kindEEnum, policy_kind.DEADLINE_MONOTONIC_PROTOCOL_LITERAL);
		addEEnumLiteral(policy_kindEEnum, policy_kind.POSIX_1003_HIGHEST_PRIORITY_FIRST_PROTOCOL_LITERAL);
		addEEnumLiteral(policy_kindEEnum, policy_kind.TIME_SHARING_BASED_ON_WAIT_TIME_PROTOCOL_LITERAL);
		addEEnumLiteral(policy_kindEEnum, policy_kind.ROUND_ROBIN_PROTOCOL_LITERAL);
		addEEnumLiteral(policy_kindEEnum, policy_kind.MAXIMUM_URGENCY_FIRST_BASED_ON_LAXITY_PROTOCOL_LITERAL);
		addEEnumLiteral(policy_kindEEnum, policy_kind.MAXIMUM_URGENCY_FIRST_BASED_ON_DEADLINE_PROTOCOL_LITERAL);
		addEEnumLiteral(policy_kindEEnum, policy_kind.DOVER_PROTOCOL_LITERAL);
		addEEnumLiteral(policy_kindEEnum, policy_kind.TIME_SHARING_BASED_ON_CPU_USAGE_PROTOCOL_LITERAL);
		addEEnumLiteral(policy_kindEEnum, policy_kind.PIPELINE_USER_DEFINED_PROTOCOL_LITERAL);
		addEEnumLiteral(policy_kindEEnum, policy_kind.NO_SCHEDULING_PROTOCOL_LITERAL);

		initEEnum(protocol_kindEEnum, protocol_kind.class, "protocol_kind");
		addEEnumLiteral(protocol_kindEEnum, protocol_kind.NO_PROTOCOL_LITERAL);
		addEEnumLiteral(protocol_kindEEnum, protocol_kind.PCP_LITERAL);
		addEEnumLiteral(protocol_kindEEnum, protocol_kind.PIP_LITERAL);
		addEEnumLiteral(protocol_kindEEnum, protocol_kind.IPCP_LITERAL);

		initEEnum(task_policy_kindEEnum, task_policy_kind.class, "task_policy_kind");
		addEEnumLiteral(task_policy_kindEEnum, task_policy_kind.SCHED_FIFO_LITERAL);
		addEEnumLiteral(task_policy_kindEEnum, task_policy_kind.SCHED_RR_LITERAL);
		addEEnumLiteral(task_policy_kindEEnum, task_policy_kind.SCHED_OTHERS_LITERAL);

		initEEnum(qs_kindEEnum, qs_kind.class, "qs_kind");
		addEEnumLiteral(qs_kindEEnum, qs_kind.QS_PP1_LITERAL);
		addEEnumLiteral(qs_kindEEnum, qs_kind.QS_MM1_LITERAL);
		addEEnumLiteral(qs_kindEEnum, qs_kind.QS_MD1_LITERAL);
		addEEnumLiteral(qs_kindEEnum, qs_kind.QS_MP1_LITERAL);
		addEEnumLiteral(qs_kindEEnum, qs_kind.QS_MG1_LITERAL);
		addEEnumLiteral(qs_kindEEnum, qs_kind.QS_MMS_LITERAL);
		addEEnumLiteral(qs_kindEEnum, qs_kind.QS_MDS_LITERAL);
		addEEnumLiteral(qs_kindEEnum, qs_kind.QS_MPS_LITERAL);
		addEEnumLiteral(qs_kindEEnum, qs_kind.QS_MGS_LITERAL);
		addEEnumLiteral(qs_kindEEnum, qs_kind.QS_MM1N_LITERAL);
		addEEnumLiteral(qs_kindEEnum, qs_kind.QS_MD1N_LITERAL);
		addEEnumLiteral(qs_kindEEnum, qs_kind.QS_MP1N_LITERAL);
		addEEnumLiteral(qs_kindEEnum, qs_kind.QS_MG1N_LITERAL);
		addEEnumLiteral(qs_kindEEnum, qs_kind.QS_MMSN_LITERAL);
		addEEnumLiteral(qs_kindEEnum, qs_kind.QS_MDSN_LITERAL);
		addEEnumLiteral(qs_kindEEnum, qs_kind.QS_MPSN_LITERAL);
		addEEnumLiteral(qs_kindEEnum, qs_kind.QS_MGSN_LITERAL);

		initEEnum(is_preemptive_kindEEnum, is_preemptive_kind.class, "is_preemptive_kind");
		addEEnumLiteral(is_preemptive_kindEEnum, is_preemptive_kind.PREEMPTIVE_LITERAL);
		addEEnumLiteral(is_preemptive_kindEEnum, is_preemptive_kind.NOT_PREEMPTIVE_LITERAL);
	}

} //LibraryPackageImpl
