/**
 * <copyright>
 * Thales MARTE To Cheddar(Copyright (c) THALES 2007 All rights reserved)
 * is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published
 * in http://www.eclipse.org/legal/epl-v10.html
 * Thales MARTE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Eclipse Public License for more details.
 * </copyright>
 *
 * $Id: protocol_kind.java,v 1.1 2008/01/23 16:59:01 emaes Exp $
 */
package cheddar.Library;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>protocol kind</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see cheddar.Library.LibraryPackage#getprotocol_kind()
 * @model
 * @generated
 */
public final class protocol_kind extends AbstractEnumerator {
	/**
	 * The '<em><b>NO PROTOCOL</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>NO PROTOCOL</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #NO_PROTOCOL_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int NO_PROTOCOL = 0;

	/**
	 * The '<em><b>PCP</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>PCP</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #PCP_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int PCP = 1;

	/**
	 * The '<em><b>PIP</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>PIP</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #PIP_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int PIP = 2;

	/**
	 * The '<em><b>IPCP</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>IPCP</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #IPCP_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int IPCP = 3;

	/**
	 * The '<em><b>NO PROTOCOL</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #NO_PROTOCOL
	 * @generated
	 * @ordered
	 */
	public static final protocol_kind NO_PROTOCOL_LITERAL = new protocol_kind(NO_PROTOCOL, "NO_PROTOCOL", "NO_PROTOCOL");

	/**
	 * The '<em><b>PCP</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #PCP
	 * @generated
	 * @ordered
	 */
	public static final protocol_kind PCP_LITERAL = new protocol_kind(PCP, "PCP", "PCP");

	/**
	 * The '<em><b>PIP</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #PIP
	 * @generated
	 * @ordered
	 */
	public static final protocol_kind PIP_LITERAL = new protocol_kind(PIP, "PIP", "PIP");

	/**
	 * The '<em><b>IPCP</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #IPCP
	 * @generated
	 * @ordered
	 */
	public static final protocol_kind IPCP_LITERAL = new protocol_kind(IPCP, "IPCP", "IPCP");

	/**
	 * An array of all the '<em><b>protocol kind</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final protocol_kind[] VALUES_ARRAY =
		new protocol_kind[] {
			NO_PROTOCOL_LITERAL,
			PCP_LITERAL,
			PIP_LITERAL,
			IPCP_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>protocol kind</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>protocol kind</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static protocol_kind get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			protocol_kind result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>protocol kind</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static protocol_kind getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			protocol_kind result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>protocol kind</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static protocol_kind get(int value) {
		switch (value) {
			case NO_PROTOCOL: return NO_PROTOCOL_LITERAL;
			case PCP: return PCP_LITERAL;
			case PIP: return PIP_LITERAL;
			case IPCP: return IPCP_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private protocol_kind(int value, String name, String literal) {
		super(value, name, literal);
	}

} //protocol_kind
