/**
 * <copyright>
 * Thales MARTE To Cheddar(Copyright (c) THALES 2007 All rights reserved)
 * is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published
 * in http://www.eclipse.org/legal/epl-v10.html
 * Thales MARTE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Eclipse Public License for more details.
 * </copyright>
 *
 * $Id: task_policy_kind.java,v 1.1 2008/01/23 16:59:01 emaes Exp $
 */
package cheddar.Library;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>task policy kind</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see cheddar.Library.LibraryPackage#gettask_policy_kind()
 * @model
 * @generated
 */
public final class task_policy_kind extends AbstractEnumerator {
	/**
	 * The '<em><b>SCHED FIFO</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>SCHED FIFO</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SCHED_FIFO_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int SCHED_FIFO = 0;

	/**
	 * The '<em><b>SCHED RR</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>SCHED RR</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SCHED_RR_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int SCHED_RR = 1;

	/**
	 * The '<em><b>SCHED OTHERS</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>SCHED OTHERS</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SCHED_OTHERS_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int SCHED_OTHERS = 2;

	/**
	 * The '<em><b>SCHED FIFO</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SCHED_FIFO
	 * @generated
	 * @ordered
	 */
	public static final task_policy_kind SCHED_FIFO_LITERAL = new task_policy_kind(SCHED_FIFO, "SCHED_FIFO", "SCHED_FIFO");

	/**
	 * The '<em><b>SCHED RR</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SCHED_RR
	 * @generated
	 * @ordered
	 */
	public static final task_policy_kind SCHED_RR_LITERAL = new task_policy_kind(SCHED_RR, "SCHED_RR", "SCHED_RR");

	/**
	 * The '<em><b>SCHED OTHERS</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SCHED_OTHERS
	 * @generated
	 * @ordered
	 */
	public static final task_policy_kind SCHED_OTHERS_LITERAL = new task_policy_kind(SCHED_OTHERS, "SCHED_OTHERS", "SCHED_OTHERS");

	/**
	 * An array of all the '<em><b>task policy kind</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final task_policy_kind[] VALUES_ARRAY =
		new task_policy_kind[] {
			SCHED_FIFO_LITERAL,
			SCHED_RR_LITERAL,
			SCHED_OTHERS_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>task policy kind</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>task policy kind</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static task_policy_kind get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			task_policy_kind result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>task policy kind</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static task_policy_kind getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			task_policy_kind result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>task policy kind</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static task_policy_kind get(int value) {
		switch (value) {
			case SCHED_FIFO: return SCHED_FIFO_LITERAL;
			case SCHED_RR: return SCHED_RR_LITERAL;
			case SCHED_OTHERS: return SCHED_OTHERS_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private task_policy_kind(int value, String name, String literal) {
		super(value, name, literal);
	}

} //task_policy_kind
