/**
 * <copyright>
 * Thales MARTE To Cheddar(Copyright (c) THALES 2007 All rights reserved)
 * is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published
 * in http://www.eclipse.org/legal/epl-v10.html
 * Thales MARTE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Eclipse Public License for more details.
 * </copyright>
 *
 * $Id: to_from_type_kind.java,v 1.1 2008/01/23 16:59:01 emaes Exp $
 */
package cheddar.Library;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>to from type kind</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see cheddar.Library.LibraryPackage#getto_from_type_kind()
 * @model
 * @generated
 */
public final class to_from_type_kind extends AbstractEnumerator {
	/**
	 * The '<em><b>Buffer</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Buffer</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #BUFFER_LITERAL
	 * @model name="buffer"
	 * @generated
	 * @ordered
	 */
	public static final int BUFFER = 0;

	/**
	 * The '<em><b>Message</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Message</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MESSAGE_LITERAL
	 * @model name="message"
	 * @generated
	 * @ordered
	 */
	public static final int MESSAGE = 1;

	/**
	 * The '<em><b>Task</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Task</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TASK_LITERAL
	 * @model name="task"
	 * @generated
	 * @ordered
	 */
	public static final int TASK = 2;

	/**
	 * The '<em><b>Buffer</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #BUFFER
	 * @generated
	 * @ordered
	 */
	public static final to_from_type_kind BUFFER_LITERAL = new to_from_type_kind(BUFFER, "buffer", "buffer");

	/**
	 * The '<em><b>Message</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MESSAGE
	 * @generated
	 * @ordered
	 */
	public static final to_from_type_kind MESSAGE_LITERAL = new to_from_type_kind(MESSAGE, "message", "message");

	/**
	 * The '<em><b>Task</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TASK
	 * @generated
	 * @ordered
	 */
	public static final to_from_type_kind TASK_LITERAL = new to_from_type_kind(TASK, "task", "task");

	/**
	 * An array of all the '<em><b>to from type kind</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final to_from_type_kind[] VALUES_ARRAY =
		new to_from_type_kind[] {
			BUFFER_LITERAL,
			MESSAGE_LITERAL,
			TASK_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>to from type kind</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>to from type kind</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static to_from_type_kind get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			to_from_type_kind result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>to from type kind</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static to_from_type_kind getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			to_from_type_kind result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>to from type kind</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static to_from_type_kind get(int value) {
		switch (value) {
			case BUFFER: return BUFFER_LITERAL;
			case MESSAGE: return MESSAGE_LITERAL;
			case TASK: return TASK_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private to_from_type_kind(int value, String name, String literal) {
		super(value, name, literal);
	}

} //to_from_type_kind
