/**
 * <copyright>
 * Thales MARTE To Cheddar(Copyright (c) THALES 2007 All rights reserved)
 * is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published
 * in http://www.eclipse.org/legal/epl-v10.html
 * Thales MARTE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Eclipse Public License for more details.
 * </copyright>
 *
 * $Id: Root.java,v 1.1 2008/01/23 16:59:01 emaes Exp $
 */
package cheddar;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Root</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link cheddar.Root#getProcessor <em>Processor</em>}</li>
 *   <li>{@link cheddar.Root#getAddress_space <em>Address space</em>}</li>
 *   <li>{@link cheddar.Root#getTask <em>Task</em>}</li>
 *   <li>{@link cheddar.Root#getBuffer <em>Buffer</em>}</li>
 *   <li>{@link cheddar.Root#getMessage <em>Message</em>}</li>
 *   <li>{@link cheddar.Root#getDependency <em>Dependency</em>}</li>
 *   <li>{@link cheddar.Root#getResource <em>Resource</em>}</li>
 *   <li>{@link cheddar.Root#getEvent_analyzer <em>Event analyzer</em>}</li>
 * </ul>
 * </p>
 *
 * @see cheddar.CheddarPackage#getRoot()
 * @model
 * @generated
 */
public interface Root extends EObject {
	/**
	 * Returns the value of the '<em><b>Processor</b></em>' containment reference list.
	 * The list contents are of type {@link cheddar.processor}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Processor</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Processor</em>' containment reference list.
	 * @see cheddar.CheddarPackage#getRoot_Processor()
	 * @model type="cheddar.processor" containment="true"
	 * @generated
	 */
	EList getProcessor();

	/**
	 * Returns the value of the '<em><b>Address space</b></em>' containment reference list.
	 * The list contents are of type {@link cheddar.address_space}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Address space</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Address space</em>' containment reference list.
	 * @see cheddar.CheddarPackage#getRoot_Address_space()
	 * @model type="cheddar.address_space" containment="true"
	 * @generated
	 */
	EList getAddress_space();

	/**
	 * Returns the value of the '<em><b>Task</b></em>' containment reference list.
	 * The list contents are of type {@link cheddar.task}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Task</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Task</em>' containment reference list.
	 * @see cheddar.CheddarPackage#getRoot_Task()
	 * @model type="cheddar.task" containment="true"
	 * @generated
	 */
	EList getTask();

	/**
	 * Returns the value of the '<em><b>Buffer</b></em>' containment reference list.
	 * The list contents are of type {@link cheddar.buffer}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Buffer</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Buffer</em>' containment reference list.
	 * @see cheddar.CheddarPackage#getRoot_Buffer()
	 * @model type="cheddar.buffer" containment="true"
	 * @generated
	 */
	EList getBuffer();

	/**
	 * Returns the value of the '<em><b>Message</b></em>' containment reference list.
	 * The list contents are of type {@link cheddar.message}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Message</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Message</em>' containment reference list.
	 * @see cheddar.CheddarPackage#getRoot_Message()
	 * @model type="cheddar.message" containment="true"
	 * @generated
	 */
	EList getMessage();

	/**
	 * Returns the value of the '<em><b>Dependency</b></em>' containment reference list.
	 * The list contents are of type {@link cheddar.dependency}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dependency</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Dependency</em>' containment reference list.
	 * @see cheddar.CheddarPackage#getRoot_Dependency()
	 * @model type="cheddar.dependency" containment="true"
	 * @generated
	 */
	EList getDependency();

	/**
	 * Returns the value of the '<em><b>Resource</b></em>' containment reference list.
	 * The list contents are of type {@link cheddar.resource}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Resource</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Resource</em>' containment reference list.
	 * @see cheddar.CheddarPackage#getRoot_Resource()
	 * @model type="cheddar.resource" containment="true"
	 * @generated
	 */
	EList getResource();

	/**
	 * Returns the value of the '<em><b>Event analyzer</b></em>' containment reference list.
	 * The list contents are of type {@link cheddar.event_analyzer}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Event analyzer</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Event analyzer</em>' containment reference list.
	 * @see cheddar.CheddarPackage#getRoot_Event_analyzer()
	 * @model type="cheddar.event_analyzer" containment="true"
	 * @generated
	 */
	EList getEvent_analyzer();

} // Root