/**
 * <copyright>
 * Thales MARTE To Cheddar(Copyright (c) THALES 2007 All rights reserved)
 * is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published
 * in http://www.eclipse.org/legal/epl-v10.html
 * Thales MARTE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Eclipse Public License for more details.
 * </copyright>
 *
 * $Id: address_space.java,v 1.1 2008/01/23 16:59:01 emaes Exp $
 */
package cheddar;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>address space</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link cheddar.address_space#getCpu_name <em>Cpu name</em>}</li>
 *   <li>{@link cheddar.address_space#getName <em>Name</em>}</li>
 *   <li>{@link cheddar.address_space#getText_memory_size <em>Text memory size</em>}</li>
 *   <li>{@link cheddar.address_space#getHeap_memory_size <em>Heap memory size</em>}</li>
 *   <li>{@link cheddar.address_space#getStack_memory_size <em>Stack memory size</em>}</li>
 *   <li>{@link cheddar.address_space#getData_memory_size <em>Data memory size</em>}</li>
 *   <li>{@link cheddar.address_space#getScheduler <em>Scheduler</em>}</li>
 * </ul>
 * </p>
 *
 * @see cheddar.CheddarPackage#getaddress_space()
 * @model
 * @generated
 */
public interface address_space extends Element {
	/**
	 * Returns the value of the '<em><b>Cpu name</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Cpu name</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Cpu name</em>' reference.
	 * @see #setCpu_name(processor)
	 * @see cheddar.CheddarPackage#getaddress_space_Cpu_name()
	 * @model required="true"
	 * @generated
	 */
	processor getCpu_name();

	/**
	 * Sets the value of the '{@link cheddar.address_space#getCpu_name <em>Cpu name</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cpu name</em>' reference.
	 * @see #getCpu_name()
	 * @generated
	 */
	void setCpu_name(processor value);

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see cheddar.CheddarPackage#getaddress_space_Name()
	 * @model required="true"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link cheddar.address_space#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Text memory size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Text memory size</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Text memory size</em>' attribute.
	 * @see #setText_memory_size(int)
	 * @see cheddar.CheddarPackage#getaddress_space_Text_memory_size()
	 * @model
	 * @generated
	 */
	int getText_memory_size();

	/**
	 * Sets the value of the '{@link cheddar.address_space#getText_memory_size <em>Text memory size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Text memory size</em>' attribute.
	 * @see #getText_memory_size()
	 * @generated
	 */
	void setText_memory_size(int value);

	/**
	 * Returns the value of the '<em><b>Heap memory size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Heap memory size</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Heap memory size</em>' attribute.
	 * @see #setHeap_memory_size(int)
	 * @see cheddar.CheddarPackage#getaddress_space_Heap_memory_size()
	 * @model
	 * @generated
	 */
	int getHeap_memory_size();

	/**
	 * Sets the value of the '{@link cheddar.address_space#getHeap_memory_size <em>Heap memory size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Heap memory size</em>' attribute.
	 * @see #getHeap_memory_size()
	 * @generated
	 */
	void setHeap_memory_size(int value);

	/**
	 * Returns the value of the '<em><b>Stack memory size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Stack memory size</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Stack memory size</em>' attribute.
	 * @see #setStack_memory_size(int)
	 * @see cheddar.CheddarPackage#getaddress_space_Stack_memory_size()
	 * @model
	 * @generated
	 */
	int getStack_memory_size();

	/**
	 * Sets the value of the '{@link cheddar.address_space#getStack_memory_size <em>Stack memory size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Stack memory size</em>' attribute.
	 * @see #getStack_memory_size()
	 * @generated
	 */
	void setStack_memory_size(int value);

	/**
	 * Returns the value of the '<em><b>Data memory size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Data memory size</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Data memory size</em>' attribute.
	 * @see #setData_memory_size(int)
	 * @see cheddar.CheddarPackage#getaddress_space_Data_memory_size()
	 * @model
	 * @generated
	 */
	int getData_memory_size();

	/**
	 * Sets the value of the '{@link cheddar.address_space#getData_memory_size <em>Data memory size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Data memory size</em>' attribute.
	 * @see #getData_memory_size()
	 * @generated
	 */
	void setData_memory_size(int value);

	/**
	 * Returns the value of the '<em><b>Scheduler</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Scheduler</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Scheduler</em>' containment reference.
	 * @see #setScheduler(scheduler)
	 * @see cheddar.CheddarPackage#getaddress_space_Scheduler()
	 * @model containment="true"
	 * @generated
	 */
	scheduler getScheduler();

	/**
	 * Sets the value of the '{@link cheddar.address_space#getScheduler <em>Scheduler</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Scheduler</em>' containment reference.
	 * @see #getScheduler()
	 * @generated
	 */
	void setScheduler(scheduler value);

} // address_space