/**
 * <copyright>
 * Thales MARTE To Cheddar(Copyright (c) THALES 2007 All rights reserved)
 * is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published
 * in http://www.eclipse.org/legal/epl-v10.html
 * Thales MARTE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Eclipse Public License for more details.
 * </copyright>
 *
 * $Id: buffer.java,v 1.1 2008/01/23 16:59:01 emaes Exp $
 */
package cheddar;

import cheddar.Library.qs_kind;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>buffer</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link cheddar.buffer#getX <em>X</em>}</li>
 *   <li>{@link cheddar.buffer#getY <em>Y</em>}</li>
 *   <li>{@link cheddar.buffer#getCpu_name <em>Cpu name</em>}</li>
 *   <li>{@link cheddar.buffer#getAddress_space_name <em>Address space name</em>}</li>
 *   <li>{@link cheddar.buffer#getBuffer_used_by <em>Buffer used by</em>}</li>
 *   <li>{@link cheddar.buffer#getName <em>Name</em>}</li>
 *   <li>{@link cheddar.buffer#getSize <em>Size</em>}</li>
 *   <li>{@link cheddar.buffer#getQs <em>Qs</em>}</li>
 * </ul>
 * </p>
 *
 * @see cheddar.CheddarPackage#getbuffer()
 * @model
 * @generated
 */
public interface buffer extends DependencyElement {
	/**
	 * Returns the value of the '<em><b>X</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>X</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>X</em>' attribute.
	 * @see #setX(int)
	 * @see cheddar.CheddarPackage#getbuffer_X()
	 * @model
	 * @generated
	 */
	int getX();

	/**
	 * Sets the value of the '{@link cheddar.buffer#getX <em>X</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>X</em>' attribute.
	 * @see #getX()
	 * @generated
	 */
	void setX(int value);

	/**
	 * Returns the value of the '<em><b>Y</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Y</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Y</em>' attribute.
	 * @see #setY(int)
	 * @see cheddar.CheddarPackage#getbuffer_Y()
	 * @model
	 * @generated
	 */
	int getY();

	/**
	 * Sets the value of the '{@link cheddar.buffer#getY <em>Y</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Y</em>' attribute.
	 * @see #getY()
	 * @generated
	 */
	void setY(int value);

	/**
	 * Returns the value of the '<em><b>Cpu name</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Cpu name</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Cpu name</em>' reference.
	 * @see #setCpu_name(processor)
	 * @see cheddar.CheddarPackage#getbuffer_Cpu_name()
	 * @model required="true"
	 * @generated
	 */
	processor getCpu_name();

	/**
	 * Sets the value of the '{@link cheddar.buffer#getCpu_name <em>Cpu name</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cpu name</em>' reference.
	 * @see #getCpu_name()
	 * @generated
	 */
	void setCpu_name(processor value);

	/**
	 * Returns the value of the '<em><b>Address space name</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Address space name</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Address space name</em>' reference.
	 * @see #setAddress_space_name(address_space)
	 * @see cheddar.CheddarPackage#getbuffer_Address_space_name()
	 * @model required="true"
	 * @generated
	 */
	address_space getAddress_space_name();

	/**
	 * Sets the value of the '{@link cheddar.buffer#getAddress_space_name <em>Address space name</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Address space name</em>' reference.
	 * @see #getAddress_space_name()
	 * @generated
	 */
	void setAddress_space_name(address_space value);

	/**
	 * Returns the value of the '<em><b>Buffer used by</b></em>' containment reference list.
	 * The list contents are of type {@link cheddar.buffer_user}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Buffer used by</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Buffer used by</em>' containment reference list.
	 * @see cheddar.CheddarPackage#getbuffer_Buffer_used_by()
	 * @model type="cheddar.buffer_user" containment="true"
	 * @generated
	 */
	EList getBuffer_used_by();

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see cheddar.CheddarPackage#getbuffer_Name()
	 * @model required="true"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link cheddar.buffer#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Size</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Size</em>' attribute.
	 * @see #setSize(int)
	 * @see cheddar.CheddarPackage#getbuffer_Size()
	 * @model required="true"
	 * @generated
	 */
	int getSize();

	/**
	 * Sets the value of the '{@link cheddar.buffer#getSize <em>Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Size</em>' attribute.
	 * @see #getSize()
	 * @generated
	 */
	void setSize(int value);

	/**
	 * Returns the value of the '<em><b>Qs</b></em>' attribute.
	 * The literals are from the enumeration {@link cheddar.Library.qs_kind}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Qs</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Qs</em>' attribute.
	 * @see cheddar.Library.qs_kind
	 * @see #setQs(qs_kind)
	 * @see cheddar.CheddarPackage#getbuffer_Qs()
	 * @model
	 * @generated
	 */
	qs_kind getQs();

	/**
	 * Sets the value of the '{@link cheddar.buffer#getQs <em>Qs</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Qs</em>' attribute.
	 * @see cheddar.Library.qs_kind
	 * @see #getQs()
	 * @generated
	 */
	void setQs(qs_kind value);

} // buffer