/**
 * <copyright>
 * Thales MARTE To Cheddar(Copyright (c) THALES 2007 All rights reserved)
 * is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published
 * in http://www.eclipse.org/legal/epl-v10.html
 * Thales MARTE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Eclipse Public License for more details.
 * </copyright>
 *
 * $Id: CheddarFactoryImpl.java,v 1.1 2008/01/23 16:59:01 emaes Exp $
 */
package cheddar.impl;

import cheddar.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class CheddarFactoryImpl extends EFactoryImpl implements CheddarFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static CheddarFactory init() {
		try {
			CheddarFactory theCheddarFactory = (CheddarFactory)EPackage.Registry.INSTANCE.getEFactory("http:///cheddar.ecore"); 
			if (theCheddarFactory != null) {
				return theCheddarFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new CheddarFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CheddarFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case CheddarPackage.PROCESSOR: return createprocessor();
			case CheddarPackage.SCHEDULER: return createscheduler();
			case CheddarPackage.NETWORK: return createnetwork();
			case CheddarPackage.ADDRESS_SPACE: return createaddress_space();
			case CheddarPackage.TASK: return createtask();
			case CheddarPackage.OFFSET: return createoffset();
			case CheddarPackage.PARAMETER: return createparameter();
			case CheddarPackage.EVENT_ANALYZER: return createevent_analyzer();
			case CheddarPackage.BUFFER: return createbuffer();
			case CheddarPackage.BUFFER_USER: return createbuffer_user();
			case CheddarPackage.DEPENDENCY: return createdependency();
			case CheddarPackage.MESSAGE: return createmessage();
			case CheddarPackage.RESOURCE_USER: return createresource_user();
			case CheddarPackage.RESOURCE: return createresource();
			case CheddarPackage.ROOT: return createRoot();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public processor createprocessor() {
		processorImpl processor = new processorImpl();
		return processor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public scheduler createscheduler() {
		schedulerImpl scheduler = new schedulerImpl();
		return scheduler;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public network createnetwork() {
		networkImpl network = new networkImpl();
		return network;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public address_space createaddress_space() {
		address_spaceImpl address_space = new address_spaceImpl();
		return address_space;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public task createtask() {
		taskImpl task = new taskImpl();
		return task;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public offset createoffset() {
		offsetImpl offset = new offsetImpl();
		return offset;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public parameter createparameter() {
		parameterImpl parameter = new parameterImpl();
		return parameter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public event_analyzer createevent_analyzer() {
		event_analyzerImpl event_analyzer = new event_analyzerImpl();
		return event_analyzer;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public buffer createbuffer() {
		bufferImpl buffer = new bufferImpl();
		return buffer;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public buffer_user createbuffer_user() {
		buffer_userImpl buffer_user = new buffer_userImpl();
		return buffer_user;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public dependency createdependency() {
		dependencyImpl dependency = new dependencyImpl();
		return dependency;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public message createmessage() {
		messageImpl message = new messageImpl();
		return message;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public resource_user createresource_user() {
		resource_userImpl resource_user = new resource_userImpl();
		return resource_user;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public resource createresource() {
		resourceImpl resource = new resourceImpl();
		return resource;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Root createRoot() {
		RootImpl root = new RootImpl();
		return root;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CheddarPackage getCheddarPackage() {
		return (CheddarPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	public static CheddarPackage getPackage() {
		return CheddarPackage.eINSTANCE;
	}

} //CheddarFactoryImpl
