/**
 * <copyright>
 * Thales MARTE To Cheddar(Copyright (c) THALES 2007 All rights reserved)
 * is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published
 * in http://www.eclipse.org/legal/epl-v10.html
 * Thales MARTE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Eclipse Public License for more details.
 * </copyright>
 *
 * $Id: RootImpl.java,v 1.1 2008/01/23 16:59:01 emaes Exp $
 */
package cheddar.impl;

import cheddar.CheddarPackage;
import cheddar.Root;
import cheddar.address_space;
import cheddar.buffer;
import cheddar.dependency;
import cheddar.event_analyzer;
import cheddar.message;
import cheddar.processor;
import cheddar.resource;
import cheddar.task;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Root</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link cheddar.impl.RootImpl#getProcessor <em>Processor</em>}</li>
 *   <li>{@link cheddar.impl.RootImpl#getAddress_space <em>Address space</em>}</li>
 *   <li>{@link cheddar.impl.RootImpl#getTask <em>Task</em>}</li>
 *   <li>{@link cheddar.impl.RootImpl#getBuffer <em>Buffer</em>}</li>
 *   <li>{@link cheddar.impl.RootImpl#getMessage <em>Message</em>}</li>
 *   <li>{@link cheddar.impl.RootImpl#getDependency <em>Dependency</em>}</li>
 *   <li>{@link cheddar.impl.RootImpl#getResource <em>Resource</em>}</li>
 *   <li>{@link cheddar.impl.RootImpl#getEvent_analyzer <em>Event analyzer</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class RootImpl extends EObjectImpl implements Root {
	/**
	 * The cached value of the '{@link #getProcessor() <em>Processor</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProcessor()
	 * @generated
	 * @ordered
	 */
	protected EList processor = null;

	/**
	 * The cached value of the '{@link #getAddress_space() <em>Address space</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAddress_space()
	 * @generated
	 * @ordered
	 */
	protected EList address_space = null;

	/**
	 * The cached value of the '{@link #getTask() <em>Task</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTask()
	 * @generated
	 * @ordered
	 */
	protected EList task = null;

	/**
	 * The cached value of the '{@link #getBuffer() <em>Buffer</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBuffer()
	 * @generated
	 * @ordered
	 */
	protected EList buffer = null;

	/**
	 * The cached value of the '{@link #getMessage() <em>Message</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMessage()
	 * @generated
	 * @ordered
	 */
	protected EList message = null;

	/**
	 * The cached value of the '{@link #getDependency() <em>Dependency</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDependency()
	 * @generated
	 * @ordered
	 */
	protected EList dependency = null;

	/**
	 * The cached value of the '{@link #getResource() <em>Resource</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getResource()
	 * @generated
	 * @ordered
	 */
	protected EList resource = null;

	/**
	 * The cached value of the '{@link #getEvent_analyzer() <em>Event analyzer</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEvent_analyzer()
	 * @generated
	 * @ordered
	 */
	protected EList event_analyzer = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RootImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return CheddarPackage.Literals.ROOT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getProcessor() {
		if (processor == null) {
			processor = new EObjectContainmentEList(processor.class, this, CheddarPackage.ROOT__PROCESSOR);
		}
		return processor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getAddress_space() {
		if (address_space == null) {
			address_space = new EObjectContainmentEList(address_space.class, this, CheddarPackage.ROOT__ADDRESS_SPACE);
		}
		return address_space;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getTask() {
		if (task == null) {
			task = new EObjectContainmentEList(task.class, this, CheddarPackage.ROOT__TASK);
		}
		return task;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getBuffer() {
		if (buffer == null) {
			buffer = new EObjectContainmentEList(buffer.class, this, CheddarPackage.ROOT__BUFFER);
		}
		return buffer;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getMessage() {
		if (message == null) {
			message = new EObjectContainmentEList(message.class, this, CheddarPackage.ROOT__MESSAGE);
		}
		return message;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getDependency() {
		if (dependency == null) {
			dependency = new EObjectContainmentEList(dependency.class, this, CheddarPackage.ROOT__DEPENDENCY);
		}
		return dependency;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getResource() {
		if (resource == null) {
			resource = new EObjectContainmentEList(resource.class, this, CheddarPackage.ROOT__RESOURCE);
		}
		return resource;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getEvent_analyzer() {
		if (event_analyzer == null) {
			event_analyzer = new EObjectContainmentEList(event_analyzer.class, this, CheddarPackage.ROOT__EVENT_ANALYZER);
		}
		return event_analyzer;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CheddarPackage.ROOT__PROCESSOR:
				return ((InternalEList)getProcessor()).basicRemove(otherEnd, msgs);
			case CheddarPackage.ROOT__ADDRESS_SPACE:
				return ((InternalEList)getAddress_space()).basicRemove(otherEnd, msgs);
			case CheddarPackage.ROOT__TASK:
				return ((InternalEList)getTask()).basicRemove(otherEnd, msgs);
			case CheddarPackage.ROOT__BUFFER:
				return ((InternalEList)getBuffer()).basicRemove(otherEnd, msgs);
			case CheddarPackage.ROOT__MESSAGE:
				return ((InternalEList)getMessage()).basicRemove(otherEnd, msgs);
			case CheddarPackage.ROOT__DEPENDENCY:
				return ((InternalEList)getDependency()).basicRemove(otherEnd, msgs);
			case CheddarPackage.ROOT__RESOURCE:
				return ((InternalEList)getResource()).basicRemove(otherEnd, msgs);
			case CheddarPackage.ROOT__EVENT_ANALYZER:
				return ((InternalEList)getEvent_analyzer()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case CheddarPackage.ROOT__PROCESSOR:
				return getProcessor();
			case CheddarPackage.ROOT__ADDRESS_SPACE:
				return getAddress_space();
			case CheddarPackage.ROOT__TASK:
				return getTask();
			case CheddarPackage.ROOT__BUFFER:
				return getBuffer();
			case CheddarPackage.ROOT__MESSAGE:
				return getMessage();
			case CheddarPackage.ROOT__DEPENDENCY:
				return getDependency();
			case CheddarPackage.ROOT__RESOURCE:
				return getResource();
			case CheddarPackage.ROOT__EVENT_ANALYZER:
				return getEvent_analyzer();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case CheddarPackage.ROOT__PROCESSOR:
				getProcessor().clear();
				getProcessor().addAll((Collection)newValue);
				return;
			case CheddarPackage.ROOT__ADDRESS_SPACE:
				getAddress_space().clear();
				getAddress_space().addAll((Collection)newValue);
				return;
			case CheddarPackage.ROOT__TASK:
				getTask().clear();
				getTask().addAll((Collection)newValue);
				return;
			case CheddarPackage.ROOT__BUFFER:
				getBuffer().clear();
				getBuffer().addAll((Collection)newValue);
				return;
			case CheddarPackage.ROOT__MESSAGE:
				getMessage().clear();
				getMessage().addAll((Collection)newValue);
				return;
			case CheddarPackage.ROOT__DEPENDENCY:
				getDependency().clear();
				getDependency().addAll((Collection)newValue);
				return;
			case CheddarPackage.ROOT__RESOURCE:
				getResource().clear();
				getResource().addAll((Collection)newValue);
				return;
			case CheddarPackage.ROOT__EVENT_ANALYZER:
				getEvent_analyzer().clear();
				getEvent_analyzer().addAll((Collection)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID) {
		switch (featureID) {
			case CheddarPackage.ROOT__PROCESSOR:
				getProcessor().clear();
				return;
			case CheddarPackage.ROOT__ADDRESS_SPACE:
				getAddress_space().clear();
				return;
			case CheddarPackage.ROOT__TASK:
				getTask().clear();
				return;
			case CheddarPackage.ROOT__BUFFER:
				getBuffer().clear();
				return;
			case CheddarPackage.ROOT__MESSAGE:
				getMessage().clear();
				return;
			case CheddarPackage.ROOT__DEPENDENCY:
				getDependency().clear();
				return;
			case CheddarPackage.ROOT__RESOURCE:
				getResource().clear();
				return;
			case CheddarPackage.ROOT__EVENT_ANALYZER:
				getEvent_analyzer().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case CheddarPackage.ROOT__PROCESSOR:
				return processor != null && !processor.isEmpty();
			case CheddarPackage.ROOT__ADDRESS_SPACE:
				return address_space != null && !address_space.isEmpty();
			case CheddarPackage.ROOT__TASK:
				return task != null && !task.isEmpty();
			case CheddarPackage.ROOT__BUFFER:
				return buffer != null && !buffer.isEmpty();
			case CheddarPackage.ROOT__MESSAGE:
				return message != null && !message.isEmpty();
			case CheddarPackage.ROOT__DEPENDENCY:
				return dependency != null && !dependency.isEmpty();
			case CheddarPackage.ROOT__RESOURCE:
				return resource != null && !resource.isEmpty();
			case CheddarPackage.ROOT__EVENT_ANALYZER:
				return event_analyzer != null && !event_analyzer.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //RootImpl