/**
 * <copyright>
 * Thales MARTE To Cheddar(Copyright (c) THALES 2007 All rights reserved)
 * is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published
 * in http://www.eclipse.org/legal/epl-v10.html
 * Thales MARTE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Eclipse Public License for more details.
 * </copyright>
 *
 * $Id: address_spaceImpl.java,v 1.1 2008/01/23 16:59:01 emaes Exp $
 */
package cheddar.impl;

import cheddar.CheddarPackage;
import cheddar.address_space;
import cheddar.processor;
import cheddar.scheduler;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>address space</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link cheddar.impl.address_spaceImpl#getCpu_name <em>Cpu name</em>}</li>
 *   <li>{@link cheddar.impl.address_spaceImpl#getName <em>Name</em>}</li>
 *   <li>{@link cheddar.impl.address_spaceImpl#getText_memory_size <em>Text memory size</em>}</li>
 *   <li>{@link cheddar.impl.address_spaceImpl#getHeap_memory_size <em>Heap memory size</em>}</li>
 *   <li>{@link cheddar.impl.address_spaceImpl#getStack_memory_size <em>Stack memory size</em>}</li>
 *   <li>{@link cheddar.impl.address_spaceImpl#getData_memory_size <em>Data memory size</em>}</li>
 *   <li>{@link cheddar.impl.address_spaceImpl#getScheduler <em>Scheduler</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class address_spaceImpl extends ElementImpl implements address_space {
	/**
	 * The cached value of the '{@link #getCpu_name() <em>Cpu name</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCpu_name()
	 * @generated
	 * @ordered
	 */
	protected processor cpu_name = null;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getText_memory_size() <em>Text memory size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getText_memory_size()
	 * @generated
	 * @ordered
	 */
	protected static final int TEXT_MEMORY_SIZE_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getText_memory_size() <em>Text memory size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getText_memory_size()
	 * @generated
	 * @ordered
	 */
	protected int text_memory_size = TEXT_MEMORY_SIZE_EDEFAULT;

	/**
	 * The default value of the '{@link #getHeap_memory_size() <em>Heap memory size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHeap_memory_size()
	 * @generated
	 * @ordered
	 */
	protected static final int HEAP_MEMORY_SIZE_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getHeap_memory_size() <em>Heap memory size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHeap_memory_size()
	 * @generated
	 * @ordered
	 */
	protected int heap_memory_size = HEAP_MEMORY_SIZE_EDEFAULT;

	/**
	 * The default value of the '{@link #getStack_memory_size() <em>Stack memory size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStack_memory_size()
	 * @generated
	 * @ordered
	 */
	protected static final int STACK_MEMORY_SIZE_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getStack_memory_size() <em>Stack memory size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStack_memory_size()
	 * @generated
	 * @ordered
	 */
	protected int stack_memory_size = STACK_MEMORY_SIZE_EDEFAULT;

	/**
	 * The default value of the '{@link #getData_memory_size() <em>Data memory size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getData_memory_size()
	 * @generated
	 * @ordered
	 */
	protected static final int DATA_MEMORY_SIZE_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getData_memory_size() <em>Data memory size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getData_memory_size()
	 * @generated
	 * @ordered
	 */
	protected int data_memory_size = DATA_MEMORY_SIZE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getScheduler() <em>Scheduler</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getScheduler()
	 * @generated
	 * @ordered
	 */
	protected scheduler scheduler = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected address_spaceImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return CheddarPackage.Literals.ADDRESS_SPACE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public processor getCpu_name() {
		if (cpu_name != null && cpu_name.eIsProxy()) {
			InternalEObject oldCpu_name = (InternalEObject)cpu_name;
			cpu_name = (processor)eResolveProxy(oldCpu_name);
			if (cpu_name != oldCpu_name) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CheddarPackage.ADDRESS_SPACE__CPU_NAME, oldCpu_name, cpu_name));
			}
		}
		return cpu_name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public processor basicGetCpu_name() {
		return cpu_name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCpu_name(processor newCpu_name) {
		processor oldCpu_name = cpu_name;
		cpu_name = newCpu_name;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.ADDRESS_SPACE__CPU_NAME, oldCpu_name, cpu_name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.ADDRESS_SPACE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getText_memory_size() {
		return text_memory_size;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setText_memory_size(int newText_memory_size) {
		int oldText_memory_size = text_memory_size;
		text_memory_size = newText_memory_size;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.ADDRESS_SPACE__TEXT_MEMORY_SIZE, oldText_memory_size, text_memory_size));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getHeap_memory_size() {
		return heap_memory_size;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setHeap_memory_size(int newHeap_memory_size) {
		int oldHeap_memory_size = heap_memory_size;
		heap_memory_size = newHeap_memory_size;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.ADDRESS_SPACE__HEAP_MEMORY_SIZE, oldHeap_memory_size, heap_memory_size));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getStack_memory_size() {
		return stack_memory_size;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStack_memory_size(int newStack_memory_size) {
		int oldStack_memory_size = stack_memory_size;
		stack_memory_size = newStack_memory_size;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.ADDRESS_SPACE__STACK_MEMORY_SIZE, oldStack_memory_size, stack_memory_size));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getData_memory_size() {
		return data_memory_size;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setData_memory_size(int newData_memory_size) {
		int oldData_memory_size = data_memory_size;
		data_memory_size = newData_memory_size;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.ADDRESS_SPACE__DATA_MEMORY_SIZE, oldData_memory_size, data_memory_size));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public scheduler getScheduler() {
		return scheduler;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetScheduler(scheduler newScheduler, NotificationChain msgs) {
		scheduler oldScheduler = scheduler;
		scheduler = newScheduler;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CheddarPackage.ADDRESS_SPACE__SCHEDULER, oldScheduler, newScheduler);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setScheduler(scheduler newScheduler) {
		if (newScheduler != scheduler) {
			NotificationChain msgs = null;
			if (scheduler != null)
				msgs = ((InternalEObject)scheduler).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CheddarPackage.ADDRESS_SPACE__SCHEDULER, null, msgs);
			if (newScheduler != null)
				msgs = ((InternalEObject)newScheduler).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - CheddarPackage.ADDRESS_SPACE__SCHEDULER, null, msgs);
			msgs = basicSetScheduler(newScheduler, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.ADDRESS_SPACE__SCHEDULER, newScheduler, newScheduler));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CheddarPackage.ADDRESS_SPACE__SCHEDULER:
				return basicSetScheduler(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case CheddarPackage.ADDRESS_SPACE__CPU_NAME:
				if (resolve) return getCpu_name();
				return basicGetCpu_name();
			case CheddarPackage.ADDRESS_SPACE__NAME:
				return getName();
			case CheddarPackage.ADDRESS_SPACE__TEXT_MEMORY_SIZE:
				return new Integer(getText_memory_size());
			case CheddarPackage.ADDRESS_SPACE__HEAP_MEMORY_SIZE:
				return new Integer(getHeap_memory_size());
			case CheddarPackage.ADDRESS_SPACE__STACK_MEMORY_SIZE:
				return new Integer(getStack_memory_size());
			case CheddarPackage.ADDRESS_SPACE__DATA_MEMORY_SIZE:
				return new Integer(getData_memory_size());
			case CheddarPackage.ADDRESS_SPACE__SCHEDULER:
				return getScheduler();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case CheddarPackage.ADDRESS_SPACE__CPU_NAME:
				setCpu_name((processor)newValue);
				return;
			case CheddarPackage.ADDRESS_SPACE__NAME:
				setName((String)newValue);
				return;
			case CheddarPackage.ADDRESS_SPACE__TEXT_MEMORY_SIZE:
				setText_memory_size(((Integer)newValue).intValue());
				return;
			case CheddarPackage.ADDRESS_SPACE__HEAP_MEMORY_SIZE:
				setHeap_memory_size(((Integer)newValue).intValue());
				return;
			case CheddarPackage.ADDRESS_SPACE__STACK_MEMORY_SIZE:
				setStack_memory_size(((Integer)newValue).intValue());
				return;
			case CheddarPackage.ADDRESS_SPACE__DATA_MEMORY_SIZE:
				setData_memory_size(((Integer)newValue).intValue());
				return;
			case CheddarPackage.ADDRESS_SPACE__SCHEDULER:
				setScheduler((scheduler)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID) {
		switch (featureID) {
			case CheddarPackage.ADDRESS_SPACE__CPU_NAME:
				setCpu_name((processor)null);
				return;
			case CheddarPackage.ADDRESS_SPACE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case CheddarPackage.ADDRESS_SPACE__TEXT_MEMORY_SIZE:
				setText_memory_size(TEXT_MEMORY_SIZE_EDEFAULT);
				return;
			case CheddarPackage.ADDRESS_SPACE__HEAP_MEMORY_SIZE:
				setHeap_memory_size(HEAP_MEMORY_SIZE_EDEFAULT);
				return;
			case CheddarPackage.ADDRESS_SPACE__STACK_MEMORY_SIZE:
				setStack_memory_size(STACK_MEMORY_SIZE_EDEFAULT);
				return;
			case CheddarPackage.ADDRESS_SPACE__DATA_MEMORY_SIZE:
				setData_memory_size(DATA_MEMORY_SIZE_EDEFAULT);
				return;
			case CheddarPackage.ADDRESS_SPACE__SCHEDULER:
				setScheduler((scheduler)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case CheddarPackage.ADDRESS_SPACE__CPU_NAME:
				return cpu_name != null;
			case CheddarPackage.ADDRESS_SPACE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case CheddarPackage.ADDRESS_SPACE__TEXT_MEMORY_SIZE:
				return text_memory_size != TEXT_MEMORY_SIZE_EDEFAULT;
			case CheddarPackage.ADDRESS_SPACE__HEAP_MEMORY_SIZE:
				return heap_memory_size != HEAP_MEMORY_SIZE_EDEFAULT;
			case CheddarPackage.ADDRESS_SPACE__STACK_MEMORY_SIZE:
				return stack_memory_size != STACK_MEMORY_SIZE_EDEFAULT;
			case CheddarPackage.ADDRESS_SPACE__DATA_MEMORY_SIZE:
				return data_memory_size != DATA_MEMORY_SIZE_EDEFAULT;
			case CheddarPackage.ADDRESS_SPACE__SCHEDULER:
				return scheduler != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", text_memory_size: ");
		result.append(text_memory_size);
		result.append(", heap_memory_size: ");
		result.append(heap_memory_size);
		result.append(", stack_memory_size: ");
		result.append(stack_memory_size);
		result.append(", data_memory_size: ");
		result.append(data_memory_size);
		result.append(')');
		return result.toString();
	}

} //address_spaceImpl