/**
 * <copyright>
 * Thales MARTE To Cheddar(Copyright (c) THALES 2007 All rights reserved)
 * is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published
 * in http://www.eclipse.org/legal/epl-v10.html
 * Thales MARTE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Eclipse Public License for more details.
 * </copyright>
 *
 * $Id: resourceImpl.java,v 1.1 2008/01/23 16:59:01 emaes Exp $
 */
package cheddar.impl;

import cheddar.CheddarPackage;

import cheddar.Library.protocol_kind;

import cheddar.address_space;
import cheddar.processor;
import cheddar.resource;
import cheddar.resource_user;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>resource</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link cheddar.impl.resourceImpl#getCpu_name <em>Cpu name</em>}</li>
 *   <li>{@link cheddar.impl.resourceImpl#getAddress_space_name <em>Address space name</em>}</li>
 *   <li>{@link cheddar.impl.resourceImpl#getResource_used_by <em>Resource used by</em>}</li>
 *   <li>{@link cheddar.impl.resourceImpl#getName <em>Name</em>}</li>
 *   <li>{@link cheddar.impl.resourceImpl#getState <em>State</em>}</li>
 *   <li>{@link cheddar.impl.resourceImpl#getProtocol <em>Protocol</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class resourceImpl extends ElementImpl implements resource {
	/**
	 * The cached value of the '{@link #getCpu_name() <em>Cpu name</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCpu_name()
	 * @generated
	 * @ordered
	 */
	protected processor cpu_name = null;

	/**
	 * The cached value of the '{@link #getAddress_space_name() <em>Address space name</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAddress_space_name()
	 * @generated
	 * @ordered
	 */
	protected address_space address_space_name = null;

	/**
	 * The cached value of the '{@link #getResource_used_by() <em>Resource used by</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getResource_used_by()
	 * @generated
	 * @ordered
	 */
	protected EList resource_used_by = null;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getState() <em>State</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getState()
	 * @generated
	 * @ordered
	 */
	protected static final int STATE_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getState() <em>State</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getState()
	 * @generated
	 * @ordered
	 */
	protected int state = STATE_EDEFAULT;

	/**
	 * The default value of the '{@link #getProtocol() <em>Protocol</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProtocol()
	 * @generated
	 * @ordered
	 */
	protected static final protocol_kind PROTOCOL_EDEFAULT = protocol_kind.NO_PROTOCOL_LITERAL;

	/**
	 * The cached value of the '{@link #getProtocol() <em>Protocol</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProtocol()
	 * @generated
	 * @ordered
	 */
	protected protocol_kind protocol = PROTOCOL_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected resourceImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return CheddarPackage.Literals.RESOURCE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public processor getCpu_name() {
		if (cpu_name != null && cpu_name.eIsProxy()) {
			InternalEObject oldCpu_name = (InternalEObject)cpu_name;
			cpu_name = (processor)eResolveProxy(oldCpu_name);
			if (cpu_name != oldCpu_name) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CheddarPackage.RESOURCE__CPU_NAME, oldCpu_name, cpu_name));
			}
		}
		return cpu_name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public processor basicGetCpu_name() {
		return cpu_name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCpu_name(processor newCpu_name) {
		processor oldCpu_name = cpu_name;
		cpu_name = newCpu_name;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.RESOURCE__CPU_NAME, oldCpu_name, cpu_name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public address_space getAddress_space_name() {
		if (address_space_name != null && address_space_name.eIsProxy()) {
			InternalEObject oldAddress_space_name = (InternalEObject)address_space_name;
			address_space_name = (address_space)eResolveProxy(oldAddress_space_name);
			if (address_space_name != oldAddress_space_name) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CheddarPackage.RESOURCE__ADDRESS_SPACE_NAME, oldAddress_space_name, address_space_name));
			}
		}
		return address_space_name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public address_space basicGetAddress_space_name() {
		return address_space_name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAddress_space_name(address_space newAddress_space_name) {
		address_space oldAddress_space_name = address_space_name;
		address_space_name = newAddress_space_name;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.RESOURCE__ADDRESS_SPACE_NAME, oldAddress_space_name, address_space_name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getResource_used_by() {
		if (resource_used_by == null) {
			resource_used_by = new EObjectContainmentEList(resource_user.class, this, CheddarPackage.RESOURCE__RESOURCE_USED_BY);
		}
		return resource_used_by;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.RESOURCE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getState() {
		return state;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setState(int newState) {
		int oldState = state;
		state = newState;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.RESOURCE__STATE, oldState, state));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public protocol_kind getProtocol() {
		return protocol;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setProtocol(protocol_kind newProtocol) {
		protocol_kind oldProtocol = protocol;
		protocol = newProtocol == null ? PROTOCOL_EDEFAULT : newProtocol;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.RESOURCE__PROTOCOL, oldProtocol, protocol));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CheddarPackage.RESOURCE__RESOURCE_USED_BY:
				return ((InternalEList)getResource_used_by()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case CheddarPackage.RESOURCE__CPU_NAME:
				if (resolve) return getCpu_name();
				return basicGetCpu_name();
			case CheddarPackage.RESOURCE__ADDRESS_SPACE_NAME:
				if (resolve) return getAddress_space_name();
				return basicGetAddress_space_name();
			case CheddarPackage.RESOURCE__RESOURCE_USED_BY:
				return getResource_used_by();
			case CheddarPackage.RESOURCE__NAME:
				return getName();
			case CheddarPackage.RESOURCE__STATE:
				return new Integer(getState());
			case CheddarPackage.RESOURCE__PROTOCOL:
				return getProtocol();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case CheddarPackage.RESOURCE__CPU_NAME:
				setCpu_name((processor)newValue);
				return;
			case CheddarPackage.RESOURCE__ADDRESS_SPACE_NAME:
				setAddress_space_name((address_space)newValue);
				return;
			case CheddarPackage.RESOURCE__RESOURCE_USED_BY:
				getResource_used_by().clear();
				getResource_used_by().addAll((Collection)newValue);
				return;
			case CheddarPackage.RESOURCE__NAME:
				setName((String)newValue);
				return;
			case CheddarPackage.RESOURCE__STATE:
				setState(((Integer)newValue).intValue());
				return;
			case CheddarPackage.RESOURCE__PROTOCOL:
				setProtocol((protocol_kind)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID) {
		switch (featureID) {
			case CheddarPackage.RESOURCE__CPU_NAME:
				setCpu_name((processor)null);
				return;
			case CheddarPackage.RESOURCE__ADDRESS_SPACE_NAME:
				setAddress_space_name((address_space)null);
				return;
			case CheddarPackage.RESOURCE__RESOURCE_USED_BY:
				getResource_used_by().clear();
				return;
			case CheddarPackage.RESOURCE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case CheddarPackage.RESOURCE__STATE:
				setState(STATE_EDEFAULT);
				return;
			case CheddarPackage.RESOURCE__PROTOCOL:
				setProtocol(PROTOCOL_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case CheddarPackage.RESOURCE__CPU_NAME:
				return cpu_name != null;
			case CheddarPackage.RESOURCE__ADDRESS_SPACE_NAME:
				return address_space_name != null;
			case CheddarPackage.RESOURCE__RESOURCE_USED_BY:
				return resource_used_by != null && !resource_used_by.isEmpty();
			case CheddarPackage.RESOURCE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case CheddarPackage.RESOURCE__STATE:
				return state != STATE_EDEFAULT;
			case CheddarPackage.RESOURCE__PROTOCOL:
				return protocol != PROTOCOL_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", state: ");
		result.append(state);
		result.append(", protocol: ");
		result.append(protocol);
		result.append(')');
		return result.toString();
	}

} //resourceImpl