/**
 * <copyright>
 * Thales MARTE To Cheddar(Copyright (c) THALES 2007 All rights reserved)
 * is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published
 * in http://www.eclipse.org/legal/epl-v10.html
 * Thales MARTE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Eclipse Public License for more details.
 * </copyright>
 *
 * $Id: taskImpl.java,v 1.1 2008/01/23 16:59:01 emaes Exp $
 */
package cheddar.impl;

import cheddar.CheddarPackage;

import cheddar.Library.task_policy_kind;
import cheddar.Library.task_type_kind;

import cheddar.address_space;
import cheddar.offset;
import cheddar.parameter;
import cheddar.processor;
import cheddar.task;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>task</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link cheddar.impl.taskImpl#getTask_type <em>Task type</em>}</li>
 *   <li>{@link cheddar.impl.taskImpl#getCpu_name <em>Cpu name</em>}</li>
 *   <li>{@link cheddar.impl.taskImpl#getAddress_space_name <em>Address space name</em>}</li>
 *   <li>{@link cheddar.impl.taskImpl#getX <em>X</em>}</li>
 *   <li>{@link cheddar.impl.taskImpl#getY <em>Y</em>}</li>
 *   <li>{@link cheddar.impl.taskImpl#getName <em>Name</em>}</li>
 *   <li>{@link cheddar.impl.taskImpl#getCapacity <em>Capacity</em>}</li>
 *   <li>{@link cheddar.impl.taskImpl#getPeriod <em>Period</em>}</li>
 *   <li>{@link cheddar.impl.taskImpl#getStart_time <em>Start time</em>}</li>
 *   <li>{@link cheddar.impl.taskImpl#getDeadline <em>Deadline</em>}</li>
 *   <li>{@link cheddar.impl.taskImpl#getPriority <em>Priority</em>}</li>
 *   <li>{@link cheddar.impl.taskImpl#getPolicy <em>Policy</em>}</li>
 *   <li>{@link cheddar.impl.taskImpl#getJitter <em>Jitter</em>}</li>
 *   <li>{@link cheddar.impl.taskImpl#getBlocking_time <em>Blocking time</em>}</li>
 *   <li>{@link cheddar.impl.taskImpl#getActivation_rule <em>Activation rule</em>}</li>
 *   <li>{@link cheddar.impl.taskImpl#getCriticality <em>Criticality</em>}</li>
 *   <li>{@link cheddar.impl.taskImpl#getSeed <em>Seed</em>}</li>
 *   <li>{@link cheddar.impl.taskImpl#isPredictable_seed <em>Predictable seed</em>}</li>
 *   <li>{@link cheddar.impl.taskImpl#getText_memory_size <em>Text memory size</em>}</li>
 *   <li>{@link cheddar.impl.taskImpl#getStack_memory_size <em>Stack memory size</em>}</li>
 *   <li>{@link cheddar.impl.taskImpl#getOffsets <em>Offsets</em>}</li>
 *   <li>{@link cheddar.impl.taskImpl#getParameters <em>Parameters</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class taskImpl extends DependencyElementImpl implements task {
	/**
	 * The default value of the '{@link #getTask_type() <em>Task type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTask_type()
	 * @generated
	 * @ordered
	 */
	protected static final task_type_kind TASK_TYPE_EDEFAULT = task_type_kind.PERIODIC_TYPE_LITERAL;

	/**
	 * The cached value of the '{@link #getTask_type() <em>Task type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTask_type()
	 * @generated
	 * @ordered
	 */
	protected task_type_kind task_type = TASK_TYPE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getCpu_name() <em>Cpu name</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCpu_name()
	 * @generated
	 * @ordered
	 */
	protected processor cpu_name = null;

	/**
	 * The cached value of the '{@link #getAddress_space_name() <em>Address space name</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAddress_space_name()
	 * @generated
	 * @ordered
	 */
	protected address_space address_space_name = null;

	/**
	 * The default value of the '{@link #getX() <em>X</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getX()
	 * @generated
	 * @ordered
	 */
	protected static final int X_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getX() <em>X</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getX()
	 * @generated
	 * @ordered
	 */
	protected int x = X_EDEFAULT;

	/**
	 * The default value of the '{@link #getY() <em>Y</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getY()
	 * @generated
	 * @ordered
	 */
	protected static final int Y_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getY() <em>Y</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getY()
	 * @generated
	 * @ordered
	 */
	protected int y = Y_EDEFAULT;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getCapacity() <em>Capacity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCapacity()
	 * @generated
	 * @ordered
	 */
	protected static final int CAPACITY_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getCapacity() <em>Capacity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCapacity()
	 * @generated
	 * @ordered
	 */
	protected int capacity = CAPACITY_EDEFAULT;

	/**
	 * The default value of the '{@link #getPeriod() <em>Period</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPeriod()
	 * @generated
	 * @ordered
	 */
	protected static final int PERIOD_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getPeriod() <em>Period</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPeriod()
	 * @generated
	 * @ordered
	 */
	protected int period = PERIOD_EDEFAULT;

	/**
	 * The default value of the '{@link #getStart_time() <em>Start time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStart_time()
	 * @generated
	 * @ordered
	 */
	protected static final int START_TIME_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getStart_time() <em>Start time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStart_time()
	 * @generated
	 * @ordered
	 */
	protected int start_time = START_TIME_EDEFAULT;

	/**
	 * The default value of the '{@link #getDeadline() <em>Deadline</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDeadline()
	 * @generated
	 * @ordered
	 */
	protected static final int DEADLINE_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getDeadline() <em>Deadline</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDeadline()
	 * @generated
	 * @ordered
	 */
	protected int deadline = DEADLINE_EDEFAULT;

	/**
	 * The default value of the '{@link #getPriority() <em>Priority</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPriority()
	 * @generated
	 * @ordered
	 */
	protected static final int PRIORITY_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getPriority() <em>Priority</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPriority()
	 * @generated
	 * @ordered
	 */
	protected int priority = PRIORITY_EDEFAULT;

	/**
	 * The default value of the '{@link #getPolicy() <em>Policy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPolicy()
	 * @generated
	 * @ordered
	 */
	protected static final task_policy_kind POLICY_EDEFAULT = task_policy_kind.SCHED_FIFO_LITERAL;

	/**
	 * The cached value of the '{@link #getPolicy() <em>Policy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPolicy()
	 * @generated
	 * @ordered
	 */
	protected task_policy_kind policy = POLICY_EDEFAULT;

	/**
	 * The default value of the '{@link #getJitter() <em>Jitter</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getJitter()
	 * @generated
	 * @ordered
	 */
	protected static final int JITTER_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getJitter() <em>Jitter</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getJitter()
	 * @generated
	 * @ordered
	 */
	protected int jitter = JITTER_EDEFAULT;

	/**
	 * The default value of the '{@link #getBlocking_time() <em>Blocking time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBlocking_time()
	 * @generated
	 * @ordered
	 */
	protected static final int BLOCKING_TIME_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getBlocking_time() <em>Blocking time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBlocking_time()
	 * @generated
	 * @ordered
	 */
	protected int blocking_time = BLOCKING_TIME_EDEFAULT;

	/**
	 * The default value of the '{@link #getActivation_rule() <em>Activation rule</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActivation_rule()
	 * @generated
	 * @ordered
	 */
	protected static final String ACTIVATION_RULE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getActivation_rule() <em>Activation rule</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActivation_rule()
	 * @generated
	 * @ordered
	 */
	protected String activation_rule = ACTIVATION_RULE_EDEFAULT;

	/**
	 * The default value of the '{@link #getCriticality() <em>Criticality</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCriticality()
	 * @generated
	 * @ordered
	 */
	protected static final String CRITICALITY_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getCriticality() <em>Criticality</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCriticality()
	 * @generated
	 * @ordered
	 */
	protected String criticality = CRITICALITY_EDEFAULT;

	/**
	 * The default value of the '{@link #getSeed() <em>Seed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSeed()
	 * @generated
	 * @ordered
	 */
	protected static final String SEED_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getSeed() <em>Seed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSeed()
	 * @generated
	 * @ordered
	 */
	protected String seed = SEED_EDEFAULT;

	/**
	 * The default value of the '{@link #isPredictable_seed() <em>Predictable seed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPredictable_seed()
	 * @generated
	 * @ordered
	 */
	protected static final boolean PREDICTABLE_SEED_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isPredictable_seed() <em>Predictable seed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPredictable_seed()
	 * @generated
	 * @ordered
	 */
	protected boolean predictable_seed = PREDICTABLE_SEED_EDEFAULT;

	/**
	 * The default value of the '{@link #getText_memory_size() <em>Text memory size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getText_memory_size()
	 * @generated
	 * @ordered
	 */
	protected static final int TEXT_MEMORY_SIZE_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getText_memory_size() <em>Text memory size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getText_memory_size()
	 * @generated
	 * @ordered
	 */
	protected int text_memory_size = TEXT_MEMORY_SIZE_EDEFAULT;

	/**
	 * The default value of the '{@link #getStack_memory_size() <em>Stack memory size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStack_memory_size()
	 * @generated
	 * @ordered
	 */
	protected static final int STACK_MEMORY_SIZE_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getStack_memory_size() <em>Stack memory size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStack_memory_size()
	 * @generated
	 * @ordered
	 */
	protected int stack_memory_size = STACK_MEMORY_SIZE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getOffsets() <em>Offsets</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOffsets()
	 * @generated
	 * @ordered
	 */
	protected EList offsets = null;

	/**
	 * The cached value of the '{@link #getParameters() <em>Parameters</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getParameters()
	 * @generated
	 * @ordered
	 */
	protected EList parameters = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected taskImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return CheddarPackage.Literals.TASK;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public task_type_kind getTask_type() {
		return task_type;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTask_type(task_type_kind newTask_type) {
		task_type_kind oldTask_type = task_type;
		task_type = newTask_type == null ? TASK_TYPE_EDEFAULT : newTask_type;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.TASK__TASK_TYPE, oldTask_type, task_type));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public processor getCpu_name() {
		if (cpu_name != null && cpu_name.eIsProxy()) {
			InternalEObject oldCpu_name = (InternalEObject)cpu_name;
			cpu_name = (processor)eResolveProxy(oldCpu_name);
			if (cpu_name != oldCpu_name) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CheddarPackage.TASK__CPU_NAME, oldCpu_name, cpu_name));
			}
		}
		return cpu_name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public processor basicGetCpu_name() {
		return cpu_name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCpu_name(processor newCpu_name) {
		processor oldCpu_name = cpu_name;
		cpu_name = newCpu_name;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.TASK__CPU_NAME, oldCpu_name, cpu_name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public address_space getAddress_space_name() {
		if (address_space_name != null && address_space_name.eIsProxy()) {
			InternalEObject oldAddress_space_name = (InternalEObject)address_space_name;
			address_space_name = (address_space)eResolveProxy(oldAddress_space_name);
			if (address_space_name != oldAddress_space_name) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CheddarPackage.TASK__ADDRESS_SPACE_NAME, oldAddress_space_name, address_space_name));
			}
		}
		return address_space_name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public address_space basicGetAddress_space_name() {
		return address_space_name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAddress_space_name(address_space newAddress_space_name) {
		address_space oldAddress_space_name = address_space_name;
		address_space_name = newAddress_space_name;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.TASK__ADDRESS_SPACE_NAME, oldAddress_space_name, address_space_name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getX() {
		return x;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setX(int newX) {
		int oldX = x;
		x = newX;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.TASK__X, oldX, x));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getY() {
		return y;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setY(int newY) {
		int oldY = y;
		y = newY;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.TASK__Y, oldY, y));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.TASK__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getCapacity() {
		return capacity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCapacity(int newCapacity) {
		int oldCapacity = capacity;
		capacity = newCapacity;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.TASK__CAPACITY, oldCapacity, capacity));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getPeriod() {
		return period;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPeriod(int newPeriod) {
		int oldPeriod = period;
		period = newPeriod;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.TASK__PERIOD, oldPeriod, period));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getStart_time() {
		return start_time;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStart_time(int newStart_time) {
		int oldStart_time = start_time;
		start_time = newStart_time;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.TASK__START_TIME, oldStart_time, start_time));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getDeadline() {
		return deadline;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDeadline(int newDeadline) {
		int oldDeadline = deadline;
		deadline = newDeadline;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.TASK__DEADLINE, oldDeadline, deadline));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getPriority() {
		return priority;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPriority(int newPriority) {
		int oldPriority = priority;
		priority = newPriority;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.TASK__PRIORITY, oldPriority, priority));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public task_policy_kind getPolicy() {
		return policy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPolicy(task_policy_kind newPolicy) {
		task_policy_kind oldPolicy = policy;
		policy = newPolicy == null ? POLICY_EDEFAULT : newPolicy;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.TASK__POLICY, oldPolicy, policy));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getJitter() {
		return jitter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setJitter(int newJitter) {
		int oldJitter = jitter;
		jitter = newJitter;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.TASK__JITTER, oldJitter, jitter));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getBlocking_time() {
		return blocking_time;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBlocking_time(int newBlocking_time) {
		int oldBlocking_time = blocking_time;
		blocking_time = newBlocking_time;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.TASK__BLOCKING_TIME, oldBlocking_time, blocking_time));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getActivation_rule() {
		return activation_rule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setActivation_rule(String newActivation_rule) {
		String oldActivation_rule = activation_rule;
		activation_rule = newActivation_rule;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.TASK__ACTIVATION_RULE, oldActivation_rule, activation_rule));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getCriticality() {
		return criticality;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCriticality(String newCriticality) {
		String oldCriticality = criticality;
		criticality = newCriticality;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.TASK__CRITICALITY, oldCriticality, criticality));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getSeed() {
		return seed;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSeed(String newSeed) {
		String oldSeed = seed;
		seed = newSeed;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.TASK__SEED, oldSeed, seed));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isPredictable_seed() {
		return predictable_seed;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPredictable_seed(boolean newPredictable_seed) {
		boolean oldPredictable_seed = predictable_seed;
		predictable_seed = newPredictable_seed;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.TASK__PREDICTABLE_SEED, oldPredictable_seed, predictable_seed));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getText_memory_size() {
		return text_memory_size;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setText_memory_size(int newText_memory_size) {
		int oldText_memory_size = text_memory_size;
		text_memory_size = newText_memory_size;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.TASK__TEXT_MEMORY_SIZE, oldText_memory_size, text_memory_size));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getStack_memory_size() {
		return stack_memory_size;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStack_memory_size(int newStack_memory_size) {
		int oldStack_memory_size = stack_memory_size;
		stack_memory_size = newStack_memory_size;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CheddarPackage.TASK__STACK_MEMORY_SIZE, oldStack_memory_size, stack_memory_size));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getOffsets() {
		if (offsets == null) {
			offsets = new EObjectContainmentEList(offset.class, this, CheddarPackage.TASK__OFFSETS);
		}
		return offsets;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getParameters() {
		if (parameters == null) {
			parameters = new EObjectContainmentEList(parameter.class, this, CheddarPackage.TASK__PARAMETERS);
		}
		return parameters;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CheddarPackage.TASK__OFFSETS:
				return ((InternalEList)getOffsets()).basicRemove(otherEnd, msgs);
			case CheddarPackage.TASK__PARAMETERS:
				return ((InternalEList)getParameters()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case CheddarPackage.TASK__TASK_TYPE:
				return getTask_type();
			case CheddarPackage.TASK__CPU_NAME:
				if (resolve) return getCpu_name();
				return basicGetCpu_name();
			case CheddarPackage.TASK__ADDRESS_SPACE_NAME:
				if (resolve) return getAddress_space_name();
				return basicGetAddress_space_name();
			case CheddarPackage.TASK__X:
				return new Integer(getX());
			case CheddarPackage.TASK__Y:
				return new Integer(getY());
			case CheddarPackage.TASK__NAME:
				return getName();
			case CheddarPackage.TASK__CAPACITY:
				return new Integer(getCapacity());
			case CheddarPackage.TASK__PERIOD:
				return new Integer(getPeriod());
			case CheddarPackage.TASK__START_TIME:
				return new Integer(getStart_time());
			case CheddarPackage.TASK__DEADLINE:
				return new Integer(getDeadline());
			case CheddarPackage.TASK__PRIORITY:
				return new Integer(getPriority());
			case CheddarPackage.TASK__POLICY:
				return getPolicy();
			case CheddarPackage.TASK__JITTER:
				return new Integer(getJitter());
			case CheddarPackage.TASK__BLOCKING_TIME:
				return new Integer(getBlocking_time());
			case CheddarPackage.TASK__ACTIVATION_RULE:
				return getActivation_rule();
			case CheddarPackage.TASK__CRITICALITY:
				return getCriticality();
			case CheddarPackage.TASK__SEED:
				return getSeed();
			case CheddarPackage.TASK__PREDICTABLE_SEED:
				return isPredictable_seed() ? Boolean.TRUE : Boolean.FALSE;
			case CheddarPackage.TASK__TEXT_MEMORY_SIZE:
				return new Integer(getText_memory_size());
			case CheddarPackage.TASK__STACK_MEMORY_SIZE:
				return new Integer(getStack_memory_size());
			case CheddarPackage.TASK__OFFSETS:
				return getOffsets();
			case CheddarPackage.TASK__PARAMETERS:
				return getParameters();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case CheddarPackage.TASK__TASK_TYPE:
				setTask_type((task_type_kind)newValue);
				return;
			case CheddarPackage.TASK__CPU_NAME:
				setCpu_name((processor)newValue);
				return;
			case CheddarPackage.TASK__ADDRESS_SPACE_NAME:
				setAddress_space_name((address_space)newValue);
				return;
			case CheddarPackage.TASK__X:
				setX(((Integer)newValue).intValue());
				return;
			case CheddarPackage.TASK__Y:
				setY(((Integer)newValue).intValue());
				return;
			case CheddarPackage.TASK__NAME:
				setName((String)newValue);
				return;
			case CheddarPackage.TASK__CAPACITY:
				setCapacity(((Integer)newValue).intValue());
				return;
			case CheddarPackage.TASK__PERIOD:
				setPeriod(((Integer)newValue).intValue());
				return;
			case CheddarPackage.TASK__START_TIME:
				setStart_time(((Integer)newValue).intValue());
				return;
			case CheddarPackage.TASK__DEADLINE:
				setDeadline(((Integer)newValue).intValue());
				return;
			case CheddarPackage.TASK__PRIORITY:
				setPriority(((Integer)newValue).intValue());
				return;
			case CheddarPackage.TASK__POLICY:
				setPolicy((task_policy_kind)newValue);
				return;
			case CheddarPackage.TASK__JITTER:
				setJitter(((Integer)newValue).intValue());
				return;
			case CheddarPackage.TASK__BLOCKING_TIME:
				setBlocking_time(((Integer)newValue).intValue());
				return;
			case CheddarPackage.TASK__ACTIVATION_RULE:
				setActivation_rule((String)newValue);
				return;
			case CheddarPackage.TASK__CRITICALITY:
				setCriticality((String)newValue);
				return;
			case CheddarPackage.TASK__SEED:
				setSeed((String)newValue);
				return;
			case CheddarPackage.TASK__PREDICTABLE_SEED:
				setPredictable_seed(((Boolean)newValue).booleanValue());
				return;
			case CheddarPackage.TASK__TEXT_MEMORY_SIZE:
				setText_memory_size(((Integer)newValue).intValue());
				return;
			case CheddarPackage.TASK__STACK_MEMORY_SIZE:
				setStack_memory_size(((Integer)newValue).intValue());
				return;
			case CheddarPackage.TASK__OFFSETS:
				getOffsets().clear();
				getOffsets().addAll((Collection)newValue);
				return;
			case CheddarPackage.TASK__PARAMETERS:
				getParameters().clear();
				getParameters().addAll((Collection)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID) {
		switch (featureID) {
			case CheddarPackage.TASK__TASK_TYPE:
				setTask_type(TASK_TYPE_EDEFAULT);
				return;
			case CheddarPackage.TASK__CPU_NAME:
				setCpu_name((processor)null);
				return;
			case CheddarPackage.TASK__ADDRESS_SPACE_NAME:
				setAddress_space_name((address_space)null);
				return;
			case CheddarPackage.TASK__X:
				setX(X_EDEFAULT);
				return;
			case CheddarPackage.TASK__Y:
				setY(Y_EDEFAULT);
				return;
			case CheddarPackage.TASK__NAME:
				setName(NAME_EDEFAULT);
				return;
			case CheddarPackage.TASK__CAPACITY:
				setCapacity(CAPACITY_EDEFAULT);
				return;
			case CheddarPackage.TASK__PERIOD:
				setPeriod(PERIOD_EDEFAULT);
				return;
			case CheddarPackage.TASK__START_TIME:
				setStart_time(START_TIME_EDEFAULT);
				return;
			case CheddarPackage.TASK__DEADLINE:
				setDeadline(DEADLINE_EDEFAULT);
				return;
			case CheddarPackage.TASK__PRIORITY:
				setPriority(PRIORITY_EDEFAULT);
				return;
			case CheddarPackage.TASK__POLICY:
				setPolicy(POLICY_EDEFAULT);
				return;
			case CheddarPackage.TASK__JITTER:
				setJitter(JITTER_EDEFAULT);
				return;
			case CheddarPackage.TASK__BLOCKING_TIME:
				setBlocking_time(BLOCKING_TIME_EDEFAULT);
				return;
			case CheddarPackage.TASK__ACTIVATION_RULE:
				setActivation_rule(ACTIVATION_RULE_EDEFAULT);
				return;
			case CheddarPackage.TASK__CRITICALITY:
				setCriticality(CRITICALITY_EDEFAULT);
				return;
			case CheddarPackage.TASK__SEED:
				setSeed(SEED_EDEFAULT);
				return;
			case CheddarPackage.TASK__PREDICTABLE_SEED:
				setPredictable_seed(PREDICTABLE_SEED_EDEFAULT);
				return;
			case CheddarPackage.TASK__TEXT_MEMORY_SIZE:
				setText_memory_size(TEXT_MEMORY_SIZE_EDEFAULT);
				return;
			case CheddarPackage.TASK__STACK_MEMORY_SIZE:
				setStack_memory_size(STACK_MEMORY_SIZE_EDEFAULT);
				return;
			case CheddarPackage.TASK__OFFSETS:
				getOffsets().clear();
				return;
			case CheddarPackage.TASK__PARAMETERS:
				getParameters().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case CheddarPackage.TASK__TASK_TYPE:
				return task_type != TASK_TYPE_EDEFAULT;
			case CheddarPackage.TASK__CPU_NAME:
				return cpu_name != null;
			case CheddarPackage.TASK__ADDRESS_SPACE_NAME:
				return address_space_name != null;
			case CheddarPackage.TASK__X:
				return x != X_EDEFAULT;
			case CheddarPackage.TASK__Y:
				return y != Y_EDEFAULT;
			case CheddarPackage.TASK__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case CheddarPackage.TASK__CAPACITY:
				return capacity != CAPACITY_EDEFAULT;
			case CheddarPackage.TASK__PERIOD:
				return period != PERIOD_EDEFAULT;
			case CheddarPackage.TASK__START_TIME:
				return start_time != START_TIME_EDEFAULT;
			case CheddarPackage.TASK__DEADLINE:
				return deadline != DEADLINE_EDEFAULT;
			case CheddarPackage.TASK__PRIORITY:
				return priority != PRIORITY_EDEFAULT;
			case CheddarPackage.TASK__POLICY:
				return policy != POLICY_EDEFAULT;
			case CheddarPackage.TASK__JITTER:
				return jitter != JITTER_EDEFAULT;
			case CheddarPackage.TASK__BLOCKING_TIME:
				return blocking_time != BLOCKING_TIME_EDEFAULT;
			case CheddarPackage.TASK__ACTIVATION_RULE:
				return ACTIVATION_RULE_EDEFAULT == null ? activation_rule != null : !ACTIVATION_RULE_EDEFAULT.equals(activation_rule);
			case CheddarPackage.TASK__CRITICALITY:
				return CRITICALITY_EDEFAULT == null ? criticality != null : !CRITICALITY_EDEFAULT.equals(criticality);
			case CheddarPackage.TASK__SEED:
				return SEED_EDEFAULT == null ? seed != null : !SEED_EDEFAULT.equals(seed);
			case CheddarPackage.TASK__PREDICTABLE_SEED:
				return predictable_seed != PREDICTABLE_SEED_EDEFAULT;
			case CheddarPackage.TASK__TEXT_MEMORY_SIZE:
				return text_memory_size != TEXT_MEMORY_SIZE_EDEFAULT;
			case CheddarPackage.TASK__STACK_MEMORY_SIZE:
				return stack_memory_size != STACK_MEMORY_SIZE_EDEFAULT;
			case CheddarPackage.TASK__OFFSETS:
				return offsets != null && !offsets.isEmpty();
			case CheddarPackage.TASK__PARAMETERS:
				return parameters != null && !parameters.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (task_type: ");
		result.append(task_type);
		result.append(", x: ");
		result.append(x);
		result.append(", y: ");
		result.append(y);
		result.append(", name: ");
		result.append(name);
		result.append(", capacity: ");
		result.append(capacity);
		result.append(", period: ");
		result.append(period);
		result.append(", start_time: ");
		result.append(start_time);
		result.append(", deadline: ");
		result.append(deadline);
		result.append(", priority: ");
		result.append(priority);
		result.append(", policy: ");
		result.append(policy);
		result.append(", jitter: ");
		result.append(jitter);
		result.append(", blocking_time: ");
		result.append(blocking_time);
		result.append(", activation_rule: ");
		result.append(activation_rule);
		result.append(", criticality: ");
		result.append(criticality);
		result.append(", seed: ");
		result.append(seed);
		result.append(", predictable_seed: ");
		result.append(predictable_seed);
		result.append(", text_memory_size: ");
		result.append(text_memory_size);
		result.append(", stack_memory_size: ");
		result.append(stack_memory_size);
		result.append(')');
		return result.toString();
	}

} //taskImpl