/**
 * <copyright>
 * Thales MARTE To Cheddar(Copyright (c) THALES 2007 All rights reserved)
 * is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published
 * in http://www.eclipse.org/legal/epl-v10.html
 * Thales MARTE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Eclipse Public License for more details.
 * </copyright>
 *
 * $Id: CheddarItemProviderAdapterFactory.java,v 1.1 2008/01/23 16:59:30 emaes Exp $
 */
package cheddar.provider;

import cheddar.util.CheddarAdapterFactory;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class CheddarItemProviderAdapterFactory extends CheddarAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection supportedTypes = new ArrayList();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CheddarItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);		
	}

	/**
	 * This keeps track of the one adapter used for all {@link cheddar.processor} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected processorItemProvider processorItemProvider;

	/**
	 * This creates an adapter for a {@link cheddar.processor}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createprocessorAdapter() {
		if (processorItemProvider == null) {
			processorItemProvider = new processorItemProvider(this);
		}

		return processorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cheddar.scheduler} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected schedulerItemProvider schedulerItemProvider;

	/**
	 * This creates an adapter for a {@link cheddar.scheduler}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createschedulerAdapter() {
		if (schedulerItemProvider == null) {
			schedulerItemProvider = new schedulerItemProvider(this);
		}

		return schedulerItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cheddar.network} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected networkItemProvider networkItemProvider;

	/**
	 * This creates an adapter for a {@link cheddar.network}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createnetworkAdapter() {
		if (networkItemProvider == null) {
			networkItemProvider = new networkItemProvider(this);
		}

		return networkItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cheddar.address_space} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected address_spaceItemProvider address_spaceItemProvider;

	/**
	 * This creates an adapter for a {@link cheddar.address_space}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createaddress_spaceAdapter() {
		if (address_spaceItemProvider == null) {
			address_spaceItemProvider = new address_spaceItemProvider(this);
		}

		return address_spaceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cheddar.task} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected taskItemProvider taskItemProvider;

	/**
	 * This creates an adapter for a {@link cheddar.task}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createtaskAdapter() {
		if (taskItemProvider == null) {
			taskItemProvider = new taskItemProvider(this);
		}

		return taskItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cheddar.offset} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected offsetItemProvider offsetItemProvider;

	/**
	 * This creates an adapter for a {@link cheddar.offset}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createoffsetAdapter() {
		if (offsetItemProvider == null) {
			offsetItemProvider = new offsetItemProvider(this);
		}

		return offsetItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cheddar.parameter} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected parameterItemProvider parameterItemProvider;

	/**
	 * This creates an adapter for a {@link cheddar.parameter}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createparameterAdapter() {
		if (parameterItemProvider == null) {
			parameterItemProvider = new parameterItemProvider(this);
		}

		return parameterItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cheddar.event_analyzer} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected event_analyzerItemProvider event_analyzerItemProvider;

	/**
	 * This creates an adapter for a {@link cheddar.event_analyzer}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createevent_analyzerAdapter() {
		if (event_analyzerItemProvider == null) {
			event_analyzerItemProvider = new event_analyzerItemProvider(this);
		}

		return event_analyzerItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cheddar.buffer} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected bufferItemProvider bufferItemProvider;

	/**
	 * This creates an adapter for a {@link cheddar.buffer}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createbufferAdapter() {
		if (bufferItemProvider == null) {
			bufferItemProvider = new bufferItemProvider(this);
		}

		return bufferItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cheddar.buffer_user} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected buffer_userItemProvider buffer_userItemProvider;

	/**
	 * This creates an adapter for a {@link cheddar.buffer_user}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createbuffer_userAdapter() {
		if (buffer_userItemProvider == null) {
			buffer_userItemProvider = new buffer_userItemProvider(this);
		}

		return buffer_userItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cheddar.dependency} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected dependencyItemProvider dependencyItemProvider;

	/**
	 * This creates an adapter for a {@link cheddar.dependency}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createdependencyAdapter() {
		if (dependencyItemProvider == null) {
			dependencyItemProvider = new dependencyItemProvider(this);
		}

		return dependencyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cheddar.message} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected messageItemProvider messageItemProvider;

	/**
	 * This creates an adapter for a {@link cheddar.message}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createmessageAdapter() {
		if (messageItemProvider == null) {
			messageItemProvider = new messageItemProvider(this);
		}

		return messageItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cheddar.resource_user} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected resource_userItemProvider resource_userItemProvider;

	/**
	 * This creates an adapter for a {@link cheddar.resource_user}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createresource_userAdapter() {
		if (resource_userItemProvider == null) {
			resource_userItemProvider = new resource_userItemProvider(this);
		}

		return resource_userItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cheddar.resource} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected resourceItemProvider resourceItemProvider;

	/**
	 * This creates an adapter for a {@link cheddar.resource}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createresourceAdapter() {
		if (resourceItemProvider == null) {
			resourceItemProvider = new resourceItemProvider(this);
		}

		return resourceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cheddar.Root} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RootItemProvider rootItemProvider;

	/**
	 * This creates an adapter for a {@link cheddar.Root}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createRootAdapter() {
		if (rootItemProvider == null) {
			rootItemProvider = new RootItemProvider(this);
		}

		return rootItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class) || (((Class)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (processorItemProvider != null) processorItemProvider.dispose();
		if (schedulerItemProvider != null) schedulerItemProvider.dispose();
		if (networkItemProvider != null) networkItemProvider.dispose();
		if (address_spaceItemProvider != null) address_spaceItemProvider.dispose();
		if (taskItemProvider != null) taskItemProvider.dispose();
		if (offsetItemProvider != null) offsetItemProvider.dispose();
		if (parameterItemProvider != null) parameterItemProvider.dispose();
		if (event_analyzerItemProvider != null) event_analyzerItemProvider.dispose();
		if (bufferItemProvider != null) bufferItemProvider.dispose();
		if (buffer_userItemProvider != null) buffer_userItemProvider.dispose();
		if (dependencyItemProvider != null) dependencyItemProvider.dispose();
		if (messageItemProvider != null) messageItemProvider.dispose();
		if (resource_userItemProvider != null) resource_userItemProvider.dispose();
		if (resourceItemProvider != null) resourceItemProvider.dispose();
		if (rootItemProvider != null) rootItemProvider.dispose();
	}

}
