/**
 * <copyright>
 * Thales MARTE To Cheddar(Copyright (c) THALES 2007 All rights reserved)
 * is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published
 * in http://www.eclipse.org/legal/epl-v10.html
 * Thales MARTE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Eclipse Public License for more details.
 * </copyright>
 *
 * $Id: RootItemProvider.java,v 1.1 2008/01/23 16:59:30 emaes Exp $
 */
package cheddar.provider;


import cheddar.CheddarFactory;
import cheddar.CheddarPackage;
import cheddar.Root;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link cheddar.Root} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class RootItemProvider
	extends ItemProviderAdapter
	implements	
		IEditingDomainItemProvider,	
		IStructuredItemContentProvider,	
		ITreeItemContentProvider,	
		IItemLabelProvider,	
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RootItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

		}
		return itemPropertyDescriptors;
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Collection getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(CheddarPackage.Literals.ROOT__PROCESSOR);
			childrenFeatures.add(CheddarPackage.Literals.ROOT__ADDRESS_SPACE);
			childrenFeatures.add(CheddarPackage.Literals.ROOT__TASK);
			childrenFeatures.add(CheddarPackage.Literals.ROOT__BUFFER);
			childrenFeatures.add(CheddarPackage.Literals.ROOT__MESSAGE);
			childrenFeatures.add(CheddarPackage.Literals.ROOT__DEPENDENCY);
			childrenFeatures.add(CheddarPackage.Literals.ROOT__RESOURCE);
			childrenFeatures.add(CheddarPackage.Literals.ROOT__EVENT_ANALYZER);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns Root.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/Root"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getText(Object object) {
		return getString("_UI_Root_type");
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(Root.class)) {
			case CheddarPackage.ROOT__PROCESSOR:
			case CheddarPackage.ROOT__ADDRESS_SPACE:
			case CheddarPackage.ROOT__TASK:
			case CheddarPackage.ROOT__BUFFER:
			case CheddarPackage.ROOT__MESSAGE:
			case CheddarPackage.ROOT__DEPENDENCY:
			case CheddarPackage.ROOT__RESOURCE:
			case CheddarPackage.ROOT__EVENT_ANALYZER:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds to the collection of {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing all of the children that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void collectNewChildDescriptors(Collection newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(CheddarPackage.Literals.ROOT__PROCESSOR,
				 CheddarFactory.eINSTANCE.createprocessor()));

		newChildDescriptors.add
			(createChildParameter
				(CheddarPackage.Literals.ROOT__ADDRESS_SPACE,
				 CheddarFactory.eINSTANCE.createaddress_space()));

		newChildDescriptors.add
			(createChildParameter
				(CheddarPackage.Literals.ROOT__TASK,
				 CheddarFactory.eINSTANCE.createtask()));

		newChildDescriptors.add
			(createChildParameter
				(CheddarPackage.Literals.ROOT__BUFFER,
				 CheddarFactory.eINSTANCE.createbuffer()));

		newChildDescriptors.add
			(createChildParameter
				(CheddarPackage.Literals.ROOT__MESSAGE,
				 CheddarFactory.eINSTANCE.createmessage()));

		newChildDescriptors.add
			(createChildParameter
				(CheddarPackage.Literals.ROOT__DEPENDENCY,
				 CheddarFactory.eINSTANCE.createdependency()));

		newChildDescriptors.add
			(createChildParameter
				(CheddarPackage.Literals.ROOT__RESOURCE,
				 CheddarFactory.eINSTANCE.createresource()));

		newChildDescriptors.add
			(createChildParameter
				(CheddarPackage.Literals.ROOT__EVENT_ANALYZER,
				 CheddarFactory.eINSTANCE.createevent_analyzer()));
	}

	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResourceLocator getResourceLocator() {
		return CheddarEditPlugin.INSTANCE;
	}

}
