/**
 * <copyright>
 * Thales MARTE To Cheddar(Copyright (c) THALES 2007 All rights reserved)
 * is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published
 * in http://www.eclipse.org/legal/epl-v10.html
 * Thales MARTE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Eclipse Public License for more details.
 * </copyright>
 *
 * $Id: resource.java,v 1.1 2008/01/23 16:59:01 emaes Exp $
 */
package cheddar;

import cheddar.Library.protocol_kind;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>resource</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link cheddar.resource#getCpu_name <em>Cpu name</em>}</li>
 *   <li>{@link cheddar.resource#getAddress_space_name <em>Address space name</em>}</li>
 *   <li>{@link cheddar.resource#getResource_used_by <em>Resource used by</em>}</li>
 *   <li>{@link cheddar.resource#getName <em>Name</em>}</li>
 *   <li>{@link cheddar.resource#getState <em>State</em>}</li>
 *   <li>{@link cheddar.resource#getProtocol <em>Protocol</em>}</li>
 * </ul>
 * </p>
 *
 * @see cheddar.CheddarPackage#getresource()
 * @model
 * @generated
 */
public interface resource extends Element {
	/**
	 * Returns the value of the '<em><b>Cpu name</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Cpu name</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Cpu name</em>' reference.
	 * @see #setCpu_name(processor)
	 * @see cheddar.CheddarPackage#getresource_Cpu_name()
	 * @model
	 * @generated
	 */
	processor getCpu_name();

	/**
	 * Sets the value of the '{@link cheddar.resource#getCpu_name <em>Cpu name</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cpu name</em>' reference.
	 * @see #getCpu_name()
	 * @generated
	 */
	void setCpu_name(processor value);

	/**
	 * Returns the value of the '<em><b>Address space name</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Address space name</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Address space name</em>' reference.
	 * @see #setAddress_space_name(address_space)
	 * @see cheddar.CheddarPackage#getresource_Address_space_name()
	 * @model
	 * @generated
	 */
	address_space getAddress_space_name();

	/**
	 * Sets the value of the '{@link cheddar.resource#getAddress_space_name <em>Address space name</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Address space name</em>' reference.
	 * @see #getAddress_space_name()
	 * @generated
	 */
	void setAddress_space_name(address_space value);

	/**
	 * Returns the value of the '<em><b>Resource used by</b></em>' containment reference list.
	 * The list contents are of type {@link cheddar.resource_user}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Resource used by</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Resource used by</em>' containment reference list.
	 * @see cheddar.CheddarPackage#getresource_Resource_used_by()
	 * @model type="cheddar.resource_user" containment="true"
	 * @generated
	 */
	EList getResource_used_by();

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see cheddar.CheddarPackage#getresource_Name()
	 * @model required="true"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link cheddar.resource#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>State</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>State</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>State</em>' attribute.
	 * @see #setState(int)
	 * @see cheddar.CheddarPackage#getresource_State()
	 * @model
	 * @generated
	 */
	int getState();

	/**
	 * Sets the value of the '{@link cheddar.resource#getState <em>State</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>State</em>' attribute.
	 * @see #getState()
	 * @generated
	 */
	void setState(int value);

	/**
	 * Returns the value of the '<em><b>Protocol</b></em>' attribute.
	 * The literals are from the enumeration {@link cheddar.Library.protocol_kind}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Protocol</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Protocol</em>' attribute.
	 * @see cheddar.Library.protocol_kind
	 * @see #setProtocol(protocol_kind)
	 * @see cheddar.CheddarPackage#getresource_Protocol()
	 * @model
	 * @generated
	 */
	protocol_kind getProtocol();

	/**
	 * Sets the value of the '{@link cheddar.resource#getProtocol <em>Protocol</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Protocol</em>' attribute.
	 * @see cheddar.Library.protocol_kind
	 * @see #getProtocol()
	 * @generated
	 */
	void setProtocol(protocol_kind value);

} // resource