/**
 * <copyright>
 * Thales MARTE To Cheddar(Copyright (c) THALES 2007 All rights reserved)
 * is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published
 * in http://www.eclipse.org/legal/epl-v10.html
 * Thales MARTE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Eclipse Public License for more details.
 * </copyright>
 *
 * $Id: task.java,v 1.1 2008/01/23 16:59:01 emaes Exp $
 */
package cheddar;

import cheddar.Library.task_policy_kind;
import cheddar.Library.task_type_kind;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>task</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link cheddar.task#getTask_type <em>Task type</em>}</li>
 *   <li>{@link cheddar.task#getCpu_name <em>Cpu name</em>}</li>
 *   <li>{@link cheddar.task#getAddress_space_name <em>Address space name</em>}</li>
 *   <li>{@link cheddar.task#getX <em>X</em>}</li>
 *   <li>{@link cheddar.task#getY <em>Y</em>}</li>
 *   <li>{@link cheddar.task#getName <em>Name</em>}</li>
 *   <li>{@link cheddar.task#getCapacity <em>Capacity</em>}</li>
 *   <li>{@link cheddar.task#getPeriod <em>Period</em>}</li>
 *   <li>{@link cheddar.task#getStart_time <em>Start time</em>}</li>
 *   <li>{@link cheddar.task#getDeadline <em>Deadline</em>}</li>
 *   <li>{@link cheddar.task#getPriority <em>Priority</em>}</li>
 *   <li>{@link cheddar.task#getPolicy <em>Policy</em>}</li>
 *   <li>{@link cheddar.task#getJitter <em>Jitter</em>}</li>
 *   <li>{@link cheddar.task#getBlocking_time <em>Blocking time</em>}</li>
 *   <li>{@link cheddar.task#getActivation_rule <em>Activation rule</em>}</li>
 *   <li>{@link cheddar.task#getCriticality <em>Criticality</em>}</li>
 *   <li>{@link cheddar.task#getSeed <em>Seed</em>}</li>
 *   <li>{@link cheddar.task#isPredictable_seed <em>Predictable seed</em>}</li>
 *   <li>{@link cheddar.task#getText_memory_size <em>Text memory size</em>}</li>
 *   <li>{@link cheddar.task#getStack_memory_size <em>Stack memory size</em>}</li>
 *   <li>{@link cheddar.task#getOffsets <em>Offsets</em>}</li>
 *   <li>{@link cheddar.task#getParameters <em>Parameters</em>}</li>
 * </ul>
 * </p>
 *
 * @see cheddar.CheddarPackage#gettask()
 * @model
 * @generated
 */
public interface task extends DependencyElement {
	/**
	 * Returns the value of the '<em><b>Task type</b></em>' attribute.
	 * The literals are from the enumeration {@link cheddar.Library.task_type_kind}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Task type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Task type</em>' attribute.
	 * @see cheddar.Library.task_type_kind
	 * @see #setTask_type(task_type_kind)
	 * @see cheddar.CheddarPackage#gettask_Task_type()
	 * @model
	 * @generated
	 */
	task_type_kind getTask_type();

	/**
	 * Sets the value of the '{@link cheddar.task#getTask_type <em>Task type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Task type</em>' attribute.
	 * @see cheddar.Library.task_type_kind
	 * @see #getTask_type()
	 * @generated
	 */
	void setTask_type(task_type_kind value);

	/**
	 * Returns the value of the '<em><b>Cpu name</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Cpu name</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Cpu name</em>' reference.
	 * @see #setCpu_name(processor)
	 * @see cheddar.CheddarPackage#gettask_Cpu_name()
	 * @model required="true"
	 * @generated
	 */
	processor getCpu_name();

	/**
	 * Sets the value of the '{@link cheddar.task#getCpu_name <em>Cpu name</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cpu name</em>' reference.
	 * @see #getCpu_name()
	 * @generated
	 */
	void setCpu_name(processor value);

	/**
	 * Returns the value of the '<em><b>Address space name</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Address space name</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Address space name</em>' reference.
	 * @see #setAddress_space_name(address_space)
	 * @see cheddar.CheddarPackage#gettask_Address_space_name()
	 * @model required="true"
	 * @generated
	 */
	address_space getAddress_space_name();

	/**
	 * Sets the value of the '{@link cheddar.task#getAddress_space_name <em>Address space name</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Address space name</em>' reference.
	 * @see #getAddress_space_name()
	 * @generated
	 */
	void setAddress_space_name(address_space value);

	/**
	 * Returns the value of the '<em><b>X</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>X</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>X</em>' attribute.
	 * @see #setX(int)
	 * @see cheddar.CheddarPackage#gettask_X()
	 * @model
	 * @generated
	 */
	int getX();

	/**
	 * Sets the value of the '{@link cheddar.task#getX <em>X</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>X</em>' attribute.
	 * @see #getX()
	 * @generated
	 */
	void setX(int value);

	/**
	 * Returns the value of the '<em><b>Y</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Y</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Y</em>' attribute.
	 * @see #setY(int)
	 * @see cheddar.CheddarPackage#gettask_Y()
	 * @model
	 * @generated
	 */
	int getY();

	/**
	 * Sets the value of the '{@link cheddar.task#getY <em>Y</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Y</em>' attribute.
	 * @see #getY()
	 * @generated
	 */
	void setY(int value);

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see cheddar.CheddarPackage#gettask_Name()
	 * @model required="true"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link cheddar.task#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Capacity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Capacity</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Capacity</em>' attribute.
	 * @see #setCapacity(int)
	 * @see cheddar.CheddarPackage#gettask_Capacity()
	 * @model required="true"
	 * @generated
	 */
	int getCapacity();

	/**
	 * Sets the value of the '{@link cheddar.task#getCapacity <em>Capacity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Capacity</em>' attribute.
	 * @see #getCapacity()
	 * @generated
	 */
	void setCapacity(int value);

	/**
	 * Returns the value of the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Period</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Period</em>' attribute.
	 * @see #setPeriod(int)
	 * @see cheddar.CheddarPackage#gettask_Period()
	 * @model
	 * @generated
	 */
	int getPeriod();

	/**
	 * Sets the value of the '{@link cheddar.task#getPeriod <em>Period</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Period</em>' attribute.
	 * @see #getPeriod()
	 * @generated
	 */
	void setPeriod(int value);

	/**
	 * Returns the value of the '<em><b>Start time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start time</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start time</em>' attribute.
	 * @see #setStart_time(int)
	 * @see cheddar.CheddarPackage#gettask_Start_time()
	 * @model
	 * @generated
	 */
	int getStart_time();

	/**
	 * Sets the value of the '{@link cheddar.task#getStart_time <em>Start time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Start time</em>' attribute.
	 * @see #getStart_time()
	 * @generated
	 */
	void setStart_time(int value);

	/**
	 * Returns the value of the '<em><b>Deadline</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Deadline</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Deadline</em>' attribute.
	 * @see #setDeadline(int)
	 * @see cheddar.CheddarPackage#gettask_Deadline()
	 * @model
	 * @generated
	 */
	int getDeadline();

	/**
	 * Sets the value of the '{@link cheddar.task#getDeadline <em>Deadline</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Deadline</em>' attribute.
	 * @see #getDeadline()
	 * @generated
	 */
	void setDeadline(int value);

	/**
	 * Returns the value of the '<em><b>Priority</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Priority</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Priority</em>' attribute.
	 * @see #setPriority(int)
	 * @see cheddar.CheddarPackage#gettask_Priority()
	 * @model
	 * @generated
	 */
	int getPriority();

	/**
	 * Sets the value of the '{@link cheddar.task#getPriority <em>Priority</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Priority</em>' attribute.
	 * @see #getPriority()
	 * @generated
	 */
	void setPriority(int value);

	/**
	 * Returns the value of the '<em><b>Policy</b></em>' attribute.
	 * The literals are from the enumeration {@link cheddar.Library.task_policy_kind}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Policy</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Policy</em>' attribute.
	 * @see cheddar.Library.task_policy_kind
	 * @see #setPolicy(task_policy_kind)
	 * @see cheddar.CheddarPackage#gettask_Policy()
	 * @model
	 * @generated
	 */
	task_policy_kind getPolicy();

	/**
	 * Sets the value of the '{@link cheddar.task#getPolicy <em>Policy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Policy</em>' attribute.
	 * @see cheddar.Library.task_policy_kind
	 * @see #getPolicy()
	 * @generated
	 */
	void setPolicy(task_policy_kind value);

	/**
	 * Returns the value of the '<em><b>Jitter</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Jitter</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Jitter</em>' attribute.
	 * @see #setJitter(int)
	 * @see cheddar.CheddarPackage#gettask_Jitter()
	 * @model
	 * @generated
	 */
	int getJitter();

	/**
	 * Sets the value of the '{@link cheddar.task#getJitter <em>Jitter</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Jitter</em>' attribute.
	 * @see #getJitter()
	 * @generated
	 */
	void setJitter(int value);

	/**
	 * Returns the value of the '<em><b>Blocking time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Blocking time</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Blocking time</em>' attribute.
	 * @see #setBlocking_time(int)
	 * @see cheddar.CheddarPackage#gettask_Blocking_time()
	 * @model
	 * @generated
	 */
	int getBlocking_time();

	/**
	 * Sets the value of the '{@link cheddar.task#getBlocking_time <em>Blocking time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Blocking time</em>' attribute.
	 * @see #getBlocking_time()
	 * @generated
	 */
	void setBlocking_time(int value);

	/**
	 * Returns the value of the '<em><b>Activation rule</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Activation rule</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Activation rule</em>' attribute.
	 * @see #setActivation_rule(String)
	 * @see cheddar.CheddarPackage#gettask_Activation_rule()
	 * @model
	 * @generated
	 */
	String getActivation_rule();

	/**
	 * Sets the value of the '{@link cheddar.task#getActivation_rule <em>Activation rule</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Activation rule</em>' attribute.
	 * @see #getActivation_rule()
	 * @generated
	 */
	void setActivation_rule(String value);

	/**
	 * Returns the value of the '<em><b>Criticality</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Criticality</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Criticality</em>' attribute.
	 * @see #setCriticality(String)
	 * @see cheddar.CheddarPackage#gettask_Criticality()
	 * @model
	 * @generated
	 */
	String getCriticality();

	/**
	 * Sets the value of the '{@link cheddar.task#getCriticality <em>Criticality</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Criticality</em>' attribute.
	 * @see #getCriticality()
	 * @generated
	 */
	void setCriticality(String value);

	/**
	 * Returns the value of the '<em><b>Seed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Seed</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Seed</em>' attribute.
	 * @see #setSeed(String)
	 * @see cheddar.CheddarPackage#gettask_Seed()
	 * @model
	 * @generated
	 */
	String getSeed();

	/**
	 * Sets the value of the '{@link cheddar.task#getSeed <em>Seed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Seed</em>' attribute.
	 * @see #getSeed()
	 * @generated
	 */
	void setSeed(String value);

	/**
	 * Returns the value of the '<em><b>Predictable seed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Predictable seed</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Predictable seed</em>' attribute.
	 * @see #setPredictable_seed(boolean)
	 * @see cheddar.CheddarPackage#gettask_Predictable_seed()
	 * @model
	 * @generated
	 */
	boolean isPredictable_seed();

	/**
	 * Sets the value of the '{@link cheddar.task#isPredictable_seed <em>Predictable seed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Predictable seed</em>' attribute.
	 * @see #isPredictable_seed()
	 * @generated
	 */
	void setPredictable_seed(boolean value);

	/**
	 * Returns the value of the '<em><b>Text memory size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Text memory size</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Text memory size</em>' attribute.
	 * @see #setText_memory_size(int)
	 * @see cheddar.CheddarPackage#gettask_Text_memory_size()
	 * @model
	 * @generated
	 */
	int getText_memory_size();

	/**
	 * Sets the value of the '{@link cheddar.task#getText_memory_size <em>Text memory size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Text memory size</em>' attribute.
	 * @see #getText_memory_size()
	 * @generated
	 */
	void setText_memory_size(int value);

	/**
	 * Returns the value of the '<em><b>Stack memory size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Stack memory size</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Stack memory size</em>' attribute.
	 * @see #setStack_memory_size(int)
	 * @see cheddar.CheddarPackage#gettask_Stack_memory_size()
	 * @model
	 * @generated
	 */
	int getStack_memory_size();

	/**
	 * Sets the value of the '{@link cheddar.task#getStack_memory_size <em>Stack memory size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Stack memory size</em>' attribute.
	 * @see #getStack_memory_size()
	 * @generated
	 */
	void setStack_memory_size(int value);

	/**
	 * Returns the value of the '<em><b>Offsets</b></em>' containment reference list.
	 * The list contents are of type {@link cheddar.offset}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Offsets</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Offsets</em>' containment reference list.
	 * @see cheddar.CheddarPackage#gettask_Offsets()
	 * @model type="cheddar.offset" containment="true"
	 * @generated
	 */
	EList getOffsets();

	/**
	 * Returns the value of the '<em><b>Parameters</b></em>' containment reference list.
	 * The list contents are of type {@link cheddar.parameter}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Parameters</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Parameters</em>' containment reference list.
	 * @see cheddar.CheddarPackage#gettask_Parameters()
	 * @model type="cheddar.parameter" containment="true"
	 * @generated
	 */
	EList getParameters();

} // task