/**
 * <copyright>
 * Thales MARTE To Cheddar(Copyright (c) THALES 2007 All rights reserved)
 * is free software; you can redistribute it and/or modify
 * it under the terms of the Eclipse Public License as published
 * in http://www.eclipse.org/legal/epl-v10.html
 * Thales MARTE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Eclipse Public License for more details.
 * </copyright>
 *
 * $Id: CheddarAdapterFactory.java,v 1.1 2008/01/23 16:59:01 emaes Exp $
 */
package cheddar.util;

import cheddar.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see cheddar.CheddarPackage
 * @generated
 */
public class CheddarAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static CheddarPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CheddarAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = CheddarPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch the delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CheddarSwitch modelSwitch =
		new CheddarSwitch() {
			public Object caseDependencyElement(DependencyElement object) {
				return createDependencyElementAdapter();
			}
			public Object caseElement(Element object) {
				return createElementAdapter();
			}
			public Object caseprocessor(processor object) {
				return createprocessorAdapter();
			}
			public Object casescheduler(scheduler object) {
				return createschedulerAdapter();
			}
			public Object casenetwork(network object) {
				return createnetworkAdapter();
			}
			public Object caseaddress_space(address_space object) {
				return createaddress_spaceAdapter();
			}
			public Object casetask(task object) {
				return createtaskAdapter();
			}
			public Object caseoffset(offset object) {
				return createoffsetAdapter();
			}
			public Object caseparameter(parameter object) {
				return createparameterAdapter();
			}
			public Object caseevent_analyzer(event_analyzer object) {
				return createevent_analyzerAdapter();
			}
			public Object casebuffer(buffer object) {
				return createbufferAdapter();
			}
			public Object casebuffer_user(buffer_user object) {
				return createbuffer_userAdapter();
			}
			public Object casedependency(dependency object) {
				return createdependencyAdapter();
			}
			public Object casemessage(message object) {
				return createmessageAdapter();
			}
			public Object caseresource_user(resource_user object) {
				return createresource_userAdapter();
			}
			public Object caseresource(resource object) {
				return createresourceAdapter();
			}
			public Object caseRoot(Root object) {
				return createRootAdapter();
			}
			public Object defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	public Adapter createAdapter(Notifier target) {
		return (Adapter)modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link cheddar.DependencyElement <em>Dependency Element</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see cheddar.DependencyElement
	 * @generated
	 */
	public Adapter createDependencyElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link cheddar.Element <em>Element</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see cheddar.Element
	 * @generated
	 */
	public Adapter createElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link cheddar.processor <em>processor</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see cheddar.processor
	 * @generated
	 */
	public Adapter createprocessorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link cheddar.scheduler <em>scheduler</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see cheddar.scheduler
	 * @generated
	 */
	public Adapter createschedulerAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link cheddar.network <em>network</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see cheddar.network
	 * @generated
	 */
	public Adapter createnetworkAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link cheddar.address_space <em>address space</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see cheddar.address_space
	 * @generated
	 */
	public Adapter createaddress_spaceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link cheddar.task <em>task</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see cheddar.task
	 * @generated
	 */
	public Adapter createtaskAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link cheddar.offset <em>offset</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see cheddar.offset
	 * @generated
	 */
	public Adapter createoffsetAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link cheddar.parameter <em>parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see cheddar.parameter
	 * @generated
	 */
	public Adapter createparameterAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link cheddar.event_analyzer <em>event analyzer</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see cheddar.event_analyzer
	 * @generated
	 */
	public Adapter createevent_analyzerAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link cheddar.buffer <em>buffer</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see cheddar.buffer
	 * @generated
	 */
	public Adapter createbufferAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link cheddar.buffer_user <em>buffer user</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see cheddar.buffer_user
	 * @generated
	 */
	public Adapter createbuffer_userAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link cheddar.dependency <em>dependency</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see cheddar.dependency
	 * @generated
	 */
	public Adapter createdependencyAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link cheddar.message <em>message</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see cheddar.message
	 * @generated
	 */
	public Adapter createmessageAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link cheddar.resource_user <em>resource user</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see cheddar.resource_user
	 * @generated
	 */
	public Adapter createresource_userAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link cheddar.resource <em>resource</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see cheddar.resource
	 * @generated
	 */
	public Adapter createresourceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link cheddar.Root <em>Root</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see cheddar.Root
	 * @generated
	 */
	public Adapter createRootAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //CheddarAdapterFactory
